{******************************************************************************}
{*                                                                            *}
{* Component:                                                  *}
{* Author:                                                       *}
{*                                                                            *}
{* Email:mail@silentium.ru                                                    *}
{* htttp://www.silentium.ru                                                   *}
{* tel: +7-0912-25-17-50                                                      *}
{* Copyright (c) Silentium 2004                                               *}
{*                                                                            *}
{******************************************************************************}
unit SiComPanel;

interface

uses
  Controls, ExtCtrls, Classes, Buttons,
  Graphics;

const
  COMPANEL_PANEL_HEIGHT = 37; //  
  COMPANEL_BEVEL_HEIGHT = 2;  //   
  COMPANEL_BTN_HEIGHT   = 25; //  
  COMPANEL_BTN_WIDTH    = 75; //  
  COMPANEL_BTN_LEFT     = 5;  //    
  COMPANEL_COM_ALL      = ' ';
  COMPANEL_COM_OK       = '';
  COMPANEL_COM_CANCEL   = '';

type

  TSiComPanel = class (TPanel)
  private
    FBevel: TBevel;
    FbtnOk: TBitBtn;
    FbtnAll: TBitBtn;
    FbtnCancel: TBitBtn;
    FpnlBtn: TPanel;
    FShowBtnAll: Boolean;
    FShowBtnCancel: Boolean;
    FShowBtnOk: Boolean;

    procedure SetShowBtnAll(const Value: Boolean);
    procedure SetShowBtnCancel(const Value: Boolean);
    procedure SetShowBtnOk(const Value: Boolean);
    function GetAllClick: TNotifyEvent;
    procedure SetAllClick(const Value: TNotifyEvent);
    function GetCancelClick: TNotifyEvent;
    function GetOkClick: TNotifyEvent;
    procedure SetCancelClick(const Value: TNotifyEvent);
    procedure SetOkClick(const Value: TNotifyEvent);
  public
    //  
    procedure TuneButttons;
    property Bevel: TBevel read FBevel write FBevel;
    // 
    property pnlBtn: TPanel read FpnlBtn;
    property btnAll: TBitBtn read FbtnAll;
    property btnOk: TBitBtn read FbtnOk;
    property btnCancel: TBitBtn read FbtnCancel;
  published
    constructor Create(AOwner: TComponent); override;
    //   
    property ShowBtnAll:    Boolean read FShowBtnAll    write SetShowBtnAll;
    property ShowBtnOk:     Boolean read FShowBtnOk     write SetShowBtnOk;
    property ShowBtnCancel: Boolean read FShowBtnCancel write SetShowBtnCancel;
    //    
    property OnAllClick: TNotifyEvent read GetAllClick write SetAllClick;
    //   Ok
    property OnOkClick: TNotifyEvent read GetOkClick write SetOkClick;
    //   Cancel
    property OnCancelClick: TNotifyEvent read GetCancelClick write SetCancelClick;
 end;

implementation


constructor TSiComPanel.Create(AOwner: TComponent);
begin
  inherited;
  FShowBtnAll := false;
  FShowBtnOk := true;
  FShowBtnCancel := true;
  //  
  Align := alBottom;
//  Self.Caption := '';
//  Locked := true;  //      
  BevelOuter := bvNone;
  Self.Height := COMPANEL_PANEL_HEIGHT;
  //   
  FBevel := TBevel.Create(Self);
  with FBevel do
  begin
    Parent := Self;
    Height := COMPANEL_BEVEL_HEIGHT;
    Align := alTop;
    Shape := bsTopLine;
  end;
  //   
  FpnlBtn := TPanel.Create(Self);
  with FpnlBtn do
  begin
    Parent := Self;
    BevelOuter := bvNone;
    BevelInner := bvNone;
    Align := alRight;
    Width := ( COMPANEL_BTN_WIDTH + COMPANEL_BTN_LEFT ) * 3 + COMPANEL_BTN_LEFT;
 //   Color := clRed;
  end;
  //  All
  FbtnAll := TBitBtn.Create(Self);
  with FbtnAll do
  begin
    Parent := FpnlBtn;
    Height := COMPANEL_BTN_HEIGHT;
    Top := Round( (Self.Height - FBevel.Height - COMPANEL_BTN_HEIGHT) / 2 );
    Left := COMPANEL_BTN_LEFT;
    Visible := FShowBtnAll;
    Caption := COMPANEL_COM_ALL;
    ModalResult := mrAll;
  end;
  //  OK
  FbtnOk := TBitBtn.Create(Self);
  with FbtnOk do
  begin
    Parent := FpnlBtn;
    Height := COMPANEL_BTN_HEIGHT;
    Top := Round( (Self.Height - FBevel.Height - COMPANEL_BTN_HEIGHT) / 2 );
    Left := COMPANEL_BTN_WIDTH + COMPANEL_BTN_LEFT * 2;
    Caption := COMPANEL_COM_OK;
    ModalResult := mrOk;
    Default := true;
  end;
  //  Cancel
  FbtnCancel := TBitBtn.Create(Self);
  with FbtnCancel do
  begin
    Parent := FpnlBtn;
    Height := COMPANEL_BTN_HEIGHT;
    Top := Round( (Self.Height - FBevel.Height - COMPANEL_BTN_HEIGHT) / 2 );
    Left := COMPANEL_BTN_WIDTH * 2 + COMPANEL_BTN_LEFT * 3;
    Caption := COMPANEL_COM_CANCEL;
    Cancel := true;
    ModalResult := mrCancel;
  end;
end;

function TSiComPanel.GetAllClick: TNotifyEvent;
begin
  Result := btnAll.OnClick;
end;

function TSiComPanel.GetCancelClick: TNotifyEvent;
begin
  Result := btnCancel.OnClick;
end;

function TSiComPanel.GetOkClick: TNotifyEvent;
begin
  Result := btnOk.OnClick;
end;

procedure TSiComPanel.SetAllClick(const Value: TNotifyEvent);
begin
  btnAll.OnClick := Value;
end;

procedure TSiComPanel.SetCancelClick(const Value: TNotifyEvent);
begin
  btnCancel.OnClick := Value;
end;

procedure TSiComPanel.SetOkClick(const Value: TNotifyEvent);
begin
  btnOk.OnClick := Value;
end;

procedure TSiComPanel.SetShowBtnAll(const Value: Boolean);
begin
  FShowBtnAll := Value;
  FbtnAll.Visible := FShowBtnAll;
end;

procedure TSiComPanel.SetShowBtnCancel(const Value: Boolean);
begin
  FShowBtnCancel := Value;
  FbtnCancel.Visible := FShowBtnCancel;
  TuneButttons;
end;

procedure TSiComPanel.SetShowBtnOk(const Value: Boolean);
begin
  FShowBtnOk := Value;
  FbtnOk.Visible := FShowBtnOk;
  TuneButttons;
end;

procedure TSiComPanel.TuneButttons;
begin
  Self.Caption := '';
  if FShowBtnOk and ( not FShowbtnCancel ) then
    FbtnOk.Left := COMPANEL_BTN_WIDTH * 2 + COMPANEL_BTN_LEFT * 3
  else
    FbtnOk.Left := COMPANEL_BTN_WIDTH + COMPANEL_BTN_LEFT * 2;
end;




end.
