{******************************************************************************}
{*                                                                            *}
{* Component:  .                                           *}
{* Author:                                                       *}
{*                                                                            *}
{* Email:mail@silentium.ru                                                    *}
{* htttp://www.silentium.ru                                                   *}
{* tel: +7-0912-25-17-50                                                      *}
{* Copyright (c) Silentium 2004-2005                                          *}
{*                                                                            *}
{******************************************************************************}
unit SiConst;

interface

uses
  Graphics, DB, DBClient;

const

  SICONST_LINE_TAB             = #9#9;                    // 
  SICONST_LINE_END             = #13#10;                  //  

  //     ,  .  . BitmapsBin
  //     -    
  SIMAINMENU_PIC_NAME_PREFIX = 'MAIN_MENU_PIC_';

  SIMAINMENU_HIDE = 'HIDE';
  SIMAINMENU_DISABLE = 'DISABLE';

  SI_TRUE_VALUE  = '';    //  
  SI_FALSE_VALUE = '';   //  
  SI_NULL_VALUE  = ''; //  

  SITEXTEDITOR_FIND_CAPTION   = '';
  SITEXTEDITOR_FIND_LABEL     = ' ';
  SITEXTEDITOR_MESS_NOT_FOUND = ' ';

  //  
  SIDBCONTROL_EDIT_BTN_WIDTH = 20;          //      
  SIDBCONTROL_EDIT_HEIGHT = 20;             //   
  SIDBCONTROL_EDIT_WIDTH = 120;             //   
  SIDBCONTROL_DATE_MASK = '!99/99/0000;';   //   
  SIDBCONTROL_DATETIME_MASK = '!99/99/0000  !90:00;';   //     

  SIDBCONTROL_EDITMASK_DATEMASK_SEM_ORIGINAL = ';';  //     ; -> ~
  SIDBCONTROL_EDITMASK_DATEMASK_SEM_NEW      = '~';  //     ; -> ~

  SICONT_ICON_TRANSPANENT_COLOR = clSilver; //   ,     
  SICONT_BUTTON_HEIGHT          = 22;       //   
  SICONT_BUTTON_WIDTH           = 23;       //   
  SICONT_SEPARATOR_WIDTH        = 8;        //   
  //  
  SIWINDOW_WIDTH  = 0.9;                    //   ,    1
  SIWINDOW_HEIGHT = 0.8;                    //   ,    1

  // 
  SIMETA_FIELDS_SEPARATOR            = '|';      //   
  SIMETA_CONNECTIONLIST_SEPARATOR    = '|';      //    
  SIMETA_FIELDNAME_SEPARATOR         = '.';      //    
  SIMETA_SWITCH_SEPARATOR            = ';';      //  
  SIMETA_RELATION_SEPARATOR          = ';';      //  
  SIMETA_RELATION_JUNCTION           = '-';      //   
  SIMETA_WINDOW_FIELD_SEPARATOR      = '-';      //       
  SIMETA_LISTBOX_VALUE_SEPARATOR     = '-';      //     
  SIMETA_AFTERCHANGE_VALUE_SEPARATOR = '-';      //        
  SIMETA_KEYFIELD_SEPARATOR          = ';';      //    
  SIMETA_KEYVALUE_SEPARATOR          = '|';      //    
  SIMETA_FIELDNAME              = 'FIELDNAME';
  SIMETA_FIELDCAPTION           = 'FIELDCAPTION';
  SIMETA_FIELDWIDTH             = 'FIELDWIDTH';
  SIMETA_FIELDORDER             = 'FIELDORDER';
  SIMETA_FIELDSWITCH            = 'FIELDSWITCH';
  SIMETA_SCRIPTTEXT             = 'SCRIPTTEXT';
  SIMETA_SCRIPTINSTANT          = 'SCRIPTINSTANT';
  SIMETA_SCRIPTRETVAR           = 'SCRIPTRETVAR';
  SIMETA_TABLEDATABASENAME      = 'TABLEDATABASENAME';
  SIMETA_TABLENAME              = 'TABLENAME';
  SIMETA_TABLEALIASNAME         = 'TABLEALIASNAME';
  SIMETA_TABLEINDEXNAME         = 'TABLEINDEXNAME';
  SIMETA_TABLERELATION          = 'TABLERELATION';

  SIMETA_SQL                   = 'SQL';
  SIMETA_EMPTYFIELD            = ' ';
  SIMETA_DATATECHNOLOGY        = 'DATATECHNOLOGY';
  SIMETA_ADO_TYPE              = 'ADO_TYPE';
  SIMETA_BDE_TYPE              = 'BDE_TYPE';
  SIMETA_CDE_TYPE              = 'CDE_TYPE';
  SIMETA_CLIENT_TYPE           = 'CLIENT_TYPE';
  SIMETA_CUSTOM_TYPE           = 'CUSTOM_TYPE';

  SIMETA_CONNECT_ADO           = 'ADO';            //   ADO
  SIMETA_CONNECT_BDE           = 'BDE';            //   BDE
  SIMETA_CONNECT_CDS           = 'CDE';            //   ClientDataSet 

  SIMETA_DATATYPE              = 'DATATYPE';
  SIMETA_DATATYPE_QUERY        = 'QUERY';
  SIMETA_DATATYPE_TABLE        = 'TABLE';
  SIMETA_DATATYPE_QUERYTABLE   = 'QUERYTABLE';
  SIMETA_DATABASENAME          = 'DATABASENAME';
  //   ADO
  SIMETA_PATH                  = 'PATH';
  SIMETA_ADO_STR_REPLACE_PATH  = '[PATH]';  //     ADO

  SIMETA_ADO_DBASE             = 'Provider=MSDASQL.1;Persist Security Info=False;Data Source= dBASE;Mode=ReadWrite;Initial Catalog=[PATH]';
  SIMETA_ADO_ACCESS            = 'Provider=MSDASQL.1;Persist Security Info=False;Data Source=  MS Access;Mode=ReadWrite;Initial Catalog=[PATH]';
  SIMETA_ADO_ACCESS_JET        = 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source=[PATH];Mode=ReadWrite;Persist Security Info=False';
  SIMETA_ADO_EXCEL             = 'Provider=Microsoft.Jet.OLEDB.4.0;User ID=Admin;Data Source=[PATH];Extended Properties=Excel 8.0';
  SIMETA_ADO_ORACLE            = 'Provider=OraOLEDB.Oracle.1;Password=MANAGER;Persist Security Info=True;User ID=SYSTEM;Data Source=[PATH]';
  SIMETA_ADO_CUSTOM            = '';

  SIMETA_DP_DBASE              = 'DBASE';
  SIMETA_DP_ACCESS             = 'ACCESS';
  SIMETA_DP_EXCEL              = 'EXCEL';
  SIMETA_DP_ORACLE             = 'ORACLE';
  SIMETA_DP_CUSTOM             = 'CUSTOM';

  SIMETA_REFRESH_AFTERPOST     = 'REFRESH_AFTERPOST';
  SIMETA_GOLAST_AFTERINSERT    = 'GOLAST_AFTERINSERT';
  SIMETA_CHECKFILTER           = 'CHECKFILTER';
  SIMETA_EDITING               = 'EDITING';

  SIMETA_SOURCE_QUERY_NAME         = 'MainQuery';          //     
  SIMETA_SOURCE_CLIENTDATASET_NAME = 'MainClientDataSet';  //     ClientDataSet
  SIMETA_CONNECTIONSTRING          = 'ConnectionString';   //  

  SIMETA_EXPORTIMPORT_FILENAME  = 'MetaSource.txt';  //    -
  SIMETA_EXPORTIMPORT_SECTION   = 'METASOURCE';      //    -

  SIMETA_SOURCE_CAPTION               = 'SOURCECAPTION';
  SIMETA_SOURCE_CONNECTION_SUCCEFUL   = ' ';
  SIMETA_SOURCE_CONNECTION_UNSUCCEFUL = '  ';

  //   {Strokov 25.08.10}
  SIMETA_BEFOREEDIT_SCRIPT     = 'BEFOREEDIT_SCRIPT';
  SIMETA_AFTEREDIT_SCRIPT      = 'AFTEREDIT_SCRIPT';
  SIMETA_BEFOREINSERT_SCRIPT   = 'BEFOREINSERT_SCRIPT';
  SIMETA_AFTERINSERT_SCRIPT    = 'AFTERINSERT_SCRIPT';
  SIMETA_BEFOREDELETE_SCRIPT   = 'BEFOREDELETE_SCRIPT';
  SIMETA_AFTERDELETE_SCRIPT    = 'AFTERDELETE_SCRIPT';
  SIMETA_ONCHANGE_SCRIPT       = 'ONCHANGE_SCRIPT';

  //  
  SIMETA_VALUECHECKED          = '';                   //  
  SIMETA_VALUEUNCHECKED        = '';                  //  
  SIMETA_EDT_PREFIX            = 'edt';                  //     
  SIMETA_COMPLEX_CAPTION       = '  '; //   
  //   
  SIMETA_AUTOCODE              = 'AUTOCODE';         // 
  SIMETA_AUTONUMBER            = 'AUTONUMBER';       // 
  SIMETA_AUTOTODAY             = 'AUTOTODAY';        //  
  SIMETA_AUTOZERO              = 'AUTOZERO';         //  -
  SIMETA_CALLMENU              = 'CALLMENU';         //       

  SIMETA_CALLSITE              = 'CALLSITE';         //      -
  SIMETA_CALLEMAIL             = 'CALLEMAIL';        //      

  SIMETA_AFTEROK               = 'AFTEROK';          //       Ok
  SIMETA_AFTERCHANGE           = 'AFTERCHANGE';      //      ;
  SIMETA_ASKOK                 = 'ASKOK';            //        .
  SIMETA_BEFOREOK              = 'BEFOREOK';         //        ( OK)
  SIMETA_CHECKBOX              = 'CHECKBOX';         //   
  SIMETA_COMPLEX               = 'COMPLEX';          //     
  SIMETA_CURRENCY              = 'CURRENCY';         // 
  SIMETA_DATETIME              = 'DATETIME';         //     
  SIMETA_DEFAULT               = 'DEFAULT';          //  -  
  SIMETA_EDITMASK              = 'EDITMASK';         //   
  SIMETA_FASTPANEL             = 'FASTPANEL';        //      
  SIMETA_FOCUS                 = 'FOCUS';            //   
  SIMETA_FORMAT                = 'FORMAT';           //   
  SIMETA_FILENAME              = 'FILENAME';         //  
  SIMETA_FILEPATH              = 'FILEPATH';         //   
  SIMETA_HIDE                  = 'HIDE';             //  
  SIMETA_INSERTONLY            = 'INSERTONLY';       //     
  SIMETA_IFEMPTY               = 'IFEMPTY';          //    ... Default
  SIMETA_LISTBOX               = 'LISTBOX';          //    
  SIMETA_CALCULATOR            = 'CALCULATOR';       //  
//  SIMETA_LOADEDPIC             = 'LOADEDPIC';        //  
  SIMETA_MEMO                  = 'MEMO';             // -
  SIMETA_POSITION              = 'POSITION';         //       .     .
  SIMETA_PAGE                  = 'PAGE';             //   
  SIMETA_READONLY              = 'READONLY';         //  
  SIMETA_SMALLREF              = 'SMALLREF';         //  
  SIMETA_WINDOW                = 'WINDOW';           //  
  SIMETA_KEY                   = 'KEY';              //   
  SIMETA_CALCULATED            = 'CALCULATED';       //  

  SIMETA_SQL_SELECT            = 'SELECT';
  SIMETA_SQL_FROM              = 'FROM';
  SIMETA_SQL_WHERE             = 'WHERE';
  SIMETA_SQL_AND               = 'AND';
  SIMETA_SQL_ORDERBY           = 'ORDER BY';
  SIMETA_SQL_GROUPBY           = 'GROUP BY';
  SIMETA_SQL_AS                = 'AS';
  SIMETA_SQL_ALLFIELDS         = '*';
  SIMETA_SQL_FIELDSCOMA        = ',';
  SIMETA_SQL_ISNULL            = 'IS NULL';
  SIMETA_SQL_LIKE              = 'LIKE';
  SIMETA_SQL_EQUAL             = '=';
  SIMETA_SQL_LIKE_PERCENT      = '%';
  SIMETA_SQL_UPPER_FUNCTION    = 'LONGRUPPER';

  SIMETA_SQL_LIKE_BEGIN        = '/* INSERT LIKE BEGIN */';
  SIMETA_SQL_LIKE_END          = '/* INSERT LIKE END */';
  SIMETA_SQL_USERFILTER_BEGIN  = '/* INSERT USERFILTER BEGIN */';
  SIMETA_SQL_USERFILTER_END    = '/* INSERT USERFILTER END */';

  SIMETA_FIELDREPLACE_LEFT     = '[';  //   
  SIMETA_FIELDREPLACE_RIGHT    = ']';  //   

  //   
  SIMETA_DETAIL_FIELDNAME_FROM         = 'DETAIL_FIELDNAME_FROM';
  SIMETA_DETAIL_FIELDNAME_TO           = 'DETAIL_FIELDNAME_TO';
  SIMETA_DETAIL_FILTERTYPE             = 'DETAIL_FILTERTYPE';
  SIMETA_DETAIL_FILTERTYPE_FILTER      = 'DETAIL_FILTERTYPE_FILTER';
  SIMETA_DETAIL_FILTERTYPE_QUERYSTRING = 'DETAIL_FILTERTYPE_QUERYSTRING';
  SIMETA_DETAIL_FILTERTYPE_QUERYPARAM  = 'DETAIL_FILTERTYPE_QUERYPARAM';

  SIMETA_GOAFTERINSERT           = 'GOAFTERINSERT';
  SIMETA_GOAFTERINSERT_NONE      = 'NONE';
  SIMETA_GOAFTERINSERT_LAST      = 'LAST';
  SIMETA_GOAFTERINSERT_INSERTED  = 'INSERTED';
  //      
  SIMETA_EDIT_FONT_STEP                = 2;
  //   
  SIDBEDIT_WINDOW_CAPTION_EDIT      = '';
  SIDBEDIT_WINDOW_CAPTION_ADD       = '';
  SIDBEDIT_WINDOW_CAPTION_ADD_MAKET = '  ';
  SIDBEDIT_WINDOW_BORDER_TOP        = 10;     //      
  SIDBEDIT_WINDOW_BORDER_LEFT       = 20;     //      
  SIDBEDIT_CELL_HEIGHT              = 50;
  SIDBEDIT_CELL_ALPHA_WIDTH         = 8;
  SIDBEDIT_CELL_ALPHA_HEIGHT        = 18;     //  
  SIDBEDIT_CELL_BORDER_TOP          = 5;      //    
  SIDBEDIT_CELL_BORDER_LEFT         = 5;      //    
  SIDBEDIT_CELL_DEFAULT             = 20;     //      
  SIDBEDIT_CELL_SIMPLE_HEIGHT       = 50;     //      (  30)
//  SIDBEDIT_CELL_EDIT_HEIGHT         = 50;     //   
  SIDBEDIT_CELL_MEMO_LINES          = 10;     //  MEMO -     
  SIDBEDIT_FIELD_LABEL_COLOR        = clBlue; //    ,    
  //   
  SIDBCUBE_DIMENSION  = 'CUBE_DIM';
  SIDBCUBE_HIDE       = 'CUBE_HIDE';
  SIDBCUBE_NONE       = 'CUBE_NONE';
  SIDBCUBE_HORIZONTAL = 'CUBE_HOR';
  SIDBCUBE_VERTICAL   = 'CUBE_VER';
  SIDBCUBE_CASE       = 'CUBE_CASE_';
  //  
  SIDBCUBE_YEAR      = 'CUBE_YEAR';
  SIDBCUBE_QUARTER   = 'CUBE_QUARTER';
  SIDBCUBE_MONTH     = 'CUBE_MONTH';
  SIDBCUBE_WEEK      = 'CUBE_WEEK';
  SIDBCUBE_DAY       = 'CUBE_DAY';
  //  
  SIDBCUBE_SUM       = 'CUBE_SUM';
  SIDBCUBE_COUNT     = 'CUBE_COUNT';
  SIDBCUBE_AVG       = 'CUBE_AVG';
  SIDBCUBE_MIN       = 'CUBE_MIN';
  SIDBCUBE_MAX       = 'CUBE_MAX';
  //   
  SIDBCUBEINI_FILE        = 'cube_tune.ini';       //    
  SIDBCUBE_INI_VERTICAL   = 'CUBE_VERTICAL';       //    
  SIDBCUBE_INI_HORIZONTAL = 'CUBE_HORIZONTAL';     //    
  SIDBCUBE_INI_NONE       = 'CUBE_NONE';           //    

  // 
  SI_SWITCH_FIELD_GRAPH_X       = 'GRAPH_X';
  SI_SWITCH_FIELD_GRAPH_Y       = 'GRAPH_Y';
  SI_SWITCH_FIELD_GRAPH_START   = 'GRAPH_START';    //     
  SI_SWITCH_FIELD_GRAPH_END     = 'GRAPH_END';      //     
  SI_SWITCH_FIELD_GRAPH_CAPTION = 'GRAPH_CAPTION';  //   
  SI_SWITCH_FIELD_COLOR         = 'GRAPH_COLOR';    //     
  SI_SWITCH_FIELD_GRAPH_TITLE   = 'GRAPH_TITLE';    //      
  SI_SWITCH_FIELD_GRAPH_TYPE    = 'GRAPH_TYPE';     //        0  5.

  // 
  SIMETALINK_PARAM_NAME        = 'PARAM_NAME';       
  SIMETALINK_PARAM_TYPE        = 'PARAM_TYPE';       
  SIMETALINK_PARAM_FIELDFROM   = 'PARAM_FIELDFROM';  
  SIMETALINK_PARAM_FIELDTO     = 'PARAM_FIELDTO';
  SIMETALINK_PARAM_VALUE       = 'PARAM_VALUE';
  SIMETALINK_PARAM_SWITCH      = 'PARAM_SWITCH';
  SIMETALINK_PARAM_SIGN        = 'PARAM_SIGN';

  SIMETALINK_PARAMETERTYPE_FILTER  = 'FILTER';   // 
  SIMETALINK_PARAMETERTYPE_INFO    = 'INFO';     //  
  SIMETALINK_PARAMETERTYPE_SPECIAL = 'SPECIAL';  //  

  SIMETALINK_PARAMETESWITCH_PLAN_BEGIN    = 'PLAN_BEGIN';    // .  
  SIMETALINK_PARAMETESWITCH_PLAN_END      = 'PLAN_END';      // .  
  SIMETALINK_PARAMETESWITCH_RANGE_BEGIN   = 'RANGE_BEGIN';   // .  
  SIMETALINK_PARAMETESWITCH_RANGE_END     = 'RANGE_END';     // .  

  SIMETALINK_PARAMETESWITCH_PLAN_BEGIN_INFO    = '.  ';
  SIMETALINK_PARAMETESWITCH_PLAN_END_INFO      = '.  ';
  SIMETALINK_PARAMETESWITCH_RANGE_BEGIN_INFO   = '.  ';
  SIMETALINK_PARAMETESWITCH_RANGE_END_INFO     = '.  ';

  SIMETALINK_PARAMETESWITCH_APP_VARIABLE   = 'APP_VARIABLE';   //  
  SIMETALINK_PARAMETESWITCH_INPUT_DATE     = 'INPUT_DATE';     //    
  SIMETALINK_PARAMETESWITCH_INPUT_FLOAT    = 'INPUT_FLOAT';    //    
  SIMETALINK_PARAMETESWITCH_INPUT_LISTBOX  = 'INPUT_LISTBOX';  //   
  SIMETALINK_PARAMETESWITCH_INPUT_CHECKBOX = 'INPUT_CHECKBOX'; //    /
  SIMETALINK_PARAMETESWITCH_INPUT_STRING   = 'INPUT_STRING';   //   
  SIMETALINK_PARAMETESWITCH_INPUT_EDITMASK = 'INPUT_EDITMASK'; //  
  SIMETALINK_PARAMETESWITCH_INPUT_WINDOW   = 'INPUT_WINDOW';   //      

  SIMETALINK_PARAMETESWITCH_APP_VARIABLE_INFO   = ' ';
  SIMETALINK_PARAMETESWITCH_INPUT_DATE_INFO     = '   ';
  SIMETALINK_PARAMETESWITCH_INPUT_FLOAT_INFO    = '   ';
  SIMETALINK_PARAMETESWITCH_INPUT_LISTBOX_INFO  = '     LISTBOX XXX-YYY-ZZZ';
  SIMETALINK_PARAMETESWITCH_INPUT_CHECKBOX_INFO = '   /';
  SIMETALINK_PARAMETESWITCH_INPUT_STRING_INFO   = '   ';   
  SIMETALINK_PARAMETESWITCH_INPUT_EDITMASK_INFO = ' . , INPUT_EDITMASK !90.00,00~1~ ';
  SIMETALINK_PARAMETESWITCH_INPUT_WINDOW_INFO   = '  : _ - _ -  '; 

  SIMETALINK_PARAMETER_SEPARATOR        = '|';                     //   
  SIMETALINK_FILTER_TEXTVALUE_SEPARATOR = '''';                    //    
  SIMETALINK_FILTER_AND                 = 'AND';                   //    
  SIMETALINK_SPECIALCLIENTDATASET_NAME  = 'SpecialClientDataSet';  //     ClientDataSet
  SIMETALINK_SPECIALPARAMETER_PREFIX    = '';                      //    
  SIMETALINK_NULLVALUE                  = 'NULL';                  //  ,   NULL

  SIMETALINK_SIGN_EQUAL                 = '=';                   //   '='
  SIMETALINK_SIGN_GREATEREQUAL          = '>=';                  //   '>='
  SIMETALINK_SIGN_LESSEQUAL             = '<=';                  //   '<='
  SIMETALINK_SIGN_LESS                  = '<';                   //   '<'
  SIMETALINK_SIGN_GREATER               = '>';                   //   '>'
  SIMETALINK_SIGN_NOTEQUAL              = '<>';                  //   '<>'
  SIMETALINK_SIGN_INSIDE                = '';
  SIMETALINK_SIGN_INSIDE_LEFT           = ' ';
  SIMETALINK_SIGN_INSIDE_RIGHT          = ' ';

  SIMETALINK_SIGN_FILE_EQUAL           = 'EQUAL';                 //   '='    INI 
  SIMETALINK_SIGN_FILE_GREATER         = 'GREATER';               //   '>'    INI 
  SIMETALINK_SIGN_FILE_LESS            = 'LESS';                  //   '<'    INI 
  SIMETALINK_SIGN_FILE_NOTEQUAL        = 'NOTEQUAL';              //   '<>'    INI 
  SIMETALINK_SIGN_FILE_GREATEREQUAL    = 'GREATEREQUAL';          //   '>='    INI 
  SIMETALINK_SIGN_FILE_LESSEQUAL       = 'LESSEQUAL';             //   '<='    INI 

  SIMETALINK_CATION_NAME   = '';
  SIMETALINK_CATION_TYPE   = '';
  SIMETALINK_CATION_FROM   = ' ';
  SIMETALINK_CATION_TO     = ' ';
  SIMETALINK_CATION_SIGN   = '';
  SIMETALINK_CATION_VALUE  = '';
  SIMETALINK_CATION_SWITCH = '';

  SIMETALINK_FILED_NAME   = 'NAME';
  SIMETALINK_FILED_TYPE   = 'TYPE';
  SIMETALINK_FILED_FROM   = 'FROM';
  SIMETALINK_FILED_TO     = 'TO';
  SIMETALINK_FILED_SIGN   = 'SIGN';
  SIMETALINK_FILED_VALUE  = 'VALUE';
  SIMETALINK_FILED_SWITCH = 'SWITCH';



  SIMETALINK_CAPTION_TEMPLATE          = 'CAPTION_TEMPLATE';      //    
   
  //   
  SIRANGEDLG_DATEBEGIN                 = 'DATEBEGIN';             //  
  SIRANGEDLG_DATEEND                   = 'DATEEND';               //  
  SIRANGEDLG_RANGETYPE                 = 'RANGETYPE';             //  

  SIRANGEDLG_RANGETYPE_DEFAULT         = 'DEFAULT';               //   -
  SIRANGEDLG_RANGETYPE_ANY             = 'ANY';                   //   
  SIRANGEDLG_YEAR                      = 'YEAR';

  SIRANGEDLG_ITEMINDEX_VALUE           = 'ITEMINDEX_VALUE';
  SIRANGEDLG_ITEMINDEX_JANUARY         = 'JANUARY';
  SIRANGEDLG_ITEMINDEX_FEBRUARY        = 'FEBRUARY';
  SIRANGEDLG_ITEMINDEX_MARCH           = 'MARCH';
  SIRANGEDLG_ITEMINDEX_APRIL           = 'APRIL';
  SIRANGEDLG_ITEMINDEX_MAY             = 'MAY';
  SIRANGEDLG_ITEMINDEX_JUNE            = 'JUNE';
  SIRANGEDLG_ITEMINDEX_JULY            = 'JULY';
  SIRANGEDLG_ITEMINDEX_AUGUST          = 'AUGUST';
  SIRANGEDLG_ITEMINDEX_SEPTEMBER       = 'SEPTEMBER';
  SIRANGEDLG_ITEMINDEX_OCTOBER         = 'OCTOBER';
  SIRANGEDLG_ITEMINDEX_NOVEMBER        = 'NOVEMBER';
  SIRANGEDLG_ITEMINDEX_DECEMBER        = 'DECEMBER';

  SIRANGEDLG_ITEMINDEX_QUATER_1        = 'QUATER_1';
  SIRANGEDLG_ITEMINDEX_QUATER_2        = 'QUATER_2';
  SIRANGEDLG_ITEMINDEX_QUATER_3        = 'QUATER_3';
  SIRANGEDLG_ITEMINDEX_QUATER_4        = 'QUATER_4';
  SIRANGEDLG_ITEMINDEX_HALFYEAR_1      = 'HALFYEAR_1';
  SIRANGEDLG_ITEMINDEX_HALFYEAR_2      = 'HALFYEAR_2';
  SIRANGEDLG_ITEMINDEX_WHOLEYEAR       = 'WHOLEYEAR';
  SIRANGEDLG_ITEMINDEX_TODAY           = 'TODAY';
  SIRANGEDLG_ITEMINDEX_THISMONTH       = 'THISMONTH';
  SIRANGEDLG_ITEMINDEX_THISYEAR        = 'THISYEAR';

  SIRANGEDLG_ITEMINDEX_LAST_3_DAYS     = 'LAST_3_DAYS';
  SIRANGEDLG_ITEMINDEX_LAST_10_DAYS    = 'LAST_10_DAYS';
  SIRANGEDLG_ITEMINDEX_LAST_14_DAYS    = 'LAST_14_DAYS';
  SIRANGEDLG_ITEMINDEX_LAST_30_DAYS    = 'LAST_30_DAYS';

  SIDATAINPUTDLG_CAPTION = ' ';
  //     

  SIDATAINPUT_WINDOW_BORDER_TOP      = 10;     //      
  SIDATAINPUT_WINDOW_BORDER_LEFT     = 20;     //      
  SIDATAINPUT_CELL_HEIGHT            = 50;
  SIDATAINPUT_CELL_WIDTH             = 400;    //  
  SIDATAINPUT_CELL_ALPHA_WIDTH       = 8;
  SIDATAINPUT_CELL_ALPHA_HEIGHT      = 18;     //  
  SIDATAINPUT_BORDER_TOP             = 5;      //    
  SIDATAINPUT_CELL_BORDER_LEFT       = 5;      //    
  SIDATAINPUT_CELL_DEFAULT           = 20;     //      
  SIDATAINPUT_CELL_SIMPLE_HEIGHT     = 30;     //   
  SIDATAINPUT_WINDOW_PARAM_SEPARATOR = '-';    //   
  SIDATAINPUT_SWITCH_SEPARATOR       = ';';    //  

  SIINIFILE_NULLSECTION = 'NULLSETION';       //    ,   NULLSETION

  //      BDE
  ALIAS_SERVER_NAME = 'SERVER NAME=';
  ALIAS_USER_NAME = 'USER NAME=';
  ALIAS_PATH = 'PATH=';
  ALIAS_DEFAULT_DRIVER = 'DEFAULT DRIVER=';
  
  //   INI      BDE
  INI_ALIAS_COUNT   = 'count';
  INI_ALIAS_NAME    = 'name_';
  INI_ALIAS_DRIVER  = 'driver_';
  INI_ALIAS_SERVER  = 'server_';
  INI_ALIAS_USER    = 'user_';
  INI_ALIAS_PATH    = 'path_';
  INI_ALIAS_DEFAULT = 'default_';

  //    
  SiTextSparators: array[0..13] of String = (' ', ':', ';', '.', ',', '=', '(',')','[',']', '<', '>'  ,#10, #13);

type
  // 
  TSign =  (snEqual, snGreater, snLess, snNotEqual, snGreaterEqual, snLessEqual, snNearEqual, snInside, snInsideLeft, snInsideRifgt);
  //   
  TDataTechnology = (dtBDE, dtADO, dtCDE, dtClient, dtCustom);
  //   
  TDataType = (dtTable, dtQuery, dtQueryTable);
  //   
  TRelationType = (rtNone, rtFilter, rtFindKey);
  //  
  TExportFormat = (efExcel, efWord, efHTML);
  //  
  TFilterType = (ftFilter, ftQueryString, ftQueryParam);
  //  
  TParameterType = (ptFilter, ptInfo, ptSpecial);
  // 
  TDirection = (diLeft, diRight, diUp, diDown);
  //  
  TValueInputType = (itString, itDate, itFloat, itCheck, itWindow, itEditMask, itList);
  //    
  TAskWindowRec = record
    Window: string;           //  
    Caption: string;          //   
    KeyFieldName: string;     //    
    Value: string;            //    
    FormatDisplayStr: string; //    
    DisplayStr: string;       //  
    Accepted: Boolean;        //    
  end;
  //   
  TSiGoAfterInsert = (aiNone, aiLast, aiInserted);
  //     
  TProgressNotifyEvent = procedure (Sender: TObject; ACurrent, AMax: LongInt; AMessage: string) of object;
  //   
  TCallModalEvent = function (AWindow, AField: string; var AResult: string): Boolean of object;
  //    
  TCallVariableEvent = function (AVarName: string): string of object;
  //    
  TCallInputEvent = function (AType: TValueInputType; ACaption, AValue: string): string of object;
  //  
  TReplaceTextEvent = function (AText: string): string of object;
  //       
  TCallWindowEvent = function (AWindow: TAskWindowRec): TAskWindowRec of object;
  //     
  TFindDataSetByName = function(const AName: string): TDataSet of object;
  //    
  TShowWindowEvent = procedure(ACaption: string) of object;
  //   DLL
  TFusionParam = class
    DataSet:       TClientDataSet; //   
    Query:         string;         //   
    Parameters:    string;         //    ';'
    Error:         string;         //  
    ErrorAdvanced: string;         //     
    Fields:        string;         //       '|'
    Info:          string;         //   
  end;

  //  -     
  TAliasInfo = record
    Name:    string;
    Driver:  string;
    Server:  string;
    User:    string;
    Path:    string;
    Default: string;
  end;


implementation

end.

