{******************************************************************************}
{*                                                                            *}
{* Component:                                          *}
{* Author:                                                       *}
{*                                                                            *}
{* Email:mail@silentium.ru                                                    *}
{* htttp://www.silentium.ru                                                   *}
{* tel: +7-0912-25-17-50                                                      *}
{* Copyright (c) Silentium 2004                                               *}
{*                                                                            *}
{******************************************************************************}
unit SiUtils;

interface

uses
  DBGrids, DB, Variants, Classes, ADODB, DBTables, Forms, SysUtils, Windows,
  StdCtrls, Mask, ScktComp, DBClient, Dialogs, Graphics, Math, Registry, ComCtrls,
  SiConst, IniFiles, StrUtils;
  
const
  SIUTILS_ORDER_BY            = 'ORDER BY';
  SIUTILS_NOT_FOUND           = '  .';
  SIUTILS_NUMBER_NOT_FOUND    = -1;
  SIUTILS_HOST_NOT_DETECTED   = ' ';
  SIUTILS_SLASH               = '\';
  SIUTILS_METHODINDD_NOTFOUND = '   %s   %s';
  SIUTILS_QUOTE_SINGLE        = '''';
  SIUTILS_QUOTE_DOUBLE        = '"';

  //    SQL-   
  function MakeSQLOrder(ASQLText, AFieldName: string): string;
  //    SQL-   
  function MakeSQLOrderByNumber(ASQLText: string; AFieldNumber: LongInt): string;
  //   
  function DaysPerMonth(AYear, AMonth: Integer): Integer;
  //     APartTwo  APartOne
  function CompareParts(APartOne, APartTwo: Variant; ASign: TSign): Boolean;
  //     
  function FieldByGridCaption(AColumns: TDBGridColumns; ACaption: string): string;
  //       
  function FieldNumberByGridCaption(AGrid: TDbGrid; xCaption: string): LongInt;
  //    
  function FieldByCaption(AFields: TFields; ACaption: string): TField;
  //    
  procedure FillDBStrings(AStrings: TStrings; APlatform: TDataTechnology; AAlias, ATable, AFieldName :string);
  //    
  function YesNo(Value: string): boolean;
  //   
  function YesNoCancel(Value: string): integer;
  //    
  function SiIntToExcelLetter(Value: LongInt): string;
  //   
  function AppPath: string;
  //   
  function SiCutWord(var ASource: string; const Border: char): string;
  //       
  // : ChangeWord('  Borland', 'Borland', 'Silentium')  '  Silentium'
  function SiChangeWord(ASource: string; OldWord, NewWord: string): string;
  //       ()
  function SiChangeWordN(const ASource, OldWord, NewWord: string): string;
  //       
  function SiChangeWords(ASource: string; OldWord, NewWord: string): string;
  //        ()
  function SiChangeWordsN(const ASource, OldWord, NewWord: string): string;
  //  ,    
  function SiIsAlpha(Value: Char): Boolean;
  //   ini- 
  function SiIniFileName: string;
  //     
  function SiFieldExists(ADataSet: TDataSet; AFieldName: string): Boolean;
  //       
  function SiInteger(AStr: string; ADefault: LongInt): LongInt;
  //  , , 
  function ExtractYear(ADate: TDateTime): Word;
  function ExtractMonth(ADate: TDateTime): Word;
  function ExtractDay(ADate: TDateTime): Word;
  //      ('ABC', 3) => 'ABCABCABC'
  function SiManyStrings(AString: string; ACount: LongInt): string;
  //     BDE
  function SiConnectDataBase(AAlias, ALogin, APassword: string): TDatabase;
  //     BDE. :   
  function SiChangeAliasParam(AAlias, AParamName, AValue: string): Boolean;
  //   (  1 000 000.[0...])
  // ADataSet -  AField -   ANumber -    
  procedure SiFormatFloatField(ADataSet: TDataSet; AField: string; ANumber: byte);
  //      ,   
  procedure SiMakeStringsSameLength(ASample, AStrings: TStrings);
  //     AString  ASwitch
  function SiSwitchOn(AString, ASwitch: string): Boolean;
  //    AString  AParamNo   ASwitch
  function SiSwitchParam(AString, ASwitch: string; AParamNo: LongInt): string;
  //     .      
  function SiStrToLatin(AString: string): string;
  //   
  function SiComputerName: string;
  //    DataSet     ADO
  // ADataSet - , AConnectionString -  ,
  // ATableType -  , ACreateFlag -   
  procedure SiCopyDataSetToADOTable(ADataSet: TDataSet; AConnectionString: string; ATableName: string; ACreateFlag: Boolean);
  //      
  procedure SiAddSlash(var AString: string);
  //    AExtName  AAppName   
  procedure SiSetAppExtention(AExtName, AAppName: string);
  //    DLL
  function SiFusionDll(ADLLName, AFuntionName: string; AFusionParam: TFusionParam): Boolean;
  //  ClientDataSet
  procedure SiCopyClientDataSet(AClientDataSetFrom, AClientDataSetTo: TClientDataSet);
  //      
  function SiParameterByName(APAramName, AString: string): string;
  //     ,  B5 -> 2 10 - 3 D1 -> 4
  function SiExcelRowFromLetter(ACell: string): LongInt;
  //     ,  B5 -> 5 10 - 10 D1 -> 1
  function SiExcelColFromLetter(ACell: string): LongInt;
  //    ,   0
  function SiLetterNumber(ALetter: string): LongInt;
  //      
  function SiCalculateLetterWidth(AFont: TFont): LongInt;
  //    AFileTo   AFileFrom    
  // AFileFrom    AEndStr     
  // ACutReturnChar -       
  function SiCopyFilePart(AFileFrom, AFileTo, ABeginStr, AEndStr: string; ACutReturnChar: Boolean): Boolean;
  //  ,   
  function SiFindStreamPosision(AFileStream: TFileStream; AString: string): LongInt;
  //      Windows
  function SiGetTempPath: string;
  // ,         
  function SiIsFilterOk(ADataSet: TDataSet): Boolean;
  //      ()
  function SiAPIFreeSpace(AResource: string): Int64;
  //    
  function SiGetAliasInfo(const AAliasName: string): TAliasInfo;
  //     ini 
  procedure SiBDEParamWrite(const AFileName: string; const ASection: string; const AAliasList: TStringList);
  //    ,   
  function SiAddPathSlash(APath: string): string;
  //   
  procedure SiSaveGridColumns(ADBGrid: TDBGrid; AStrings: TStrings);
  //   
  procedure SiLoadGridColumns(ADBGrid: TDBGrid; AStrings: TStrings);
  //    .
  function SiReplaceStringFromDataSet(AString: string; ADataSet: TDataSet): string;
  //     
  function SiReplaceStringByTags(AString, ANewVale, ATagFrom, ATagTo: string): string;
  //    
  function SiGetStringByTags(AString, ATagFrom, ATagTo: string): string;
  //    Like
  function SiAddSQLLike(ASQLText, AFieldName, AValue: string; ACondition, ARegister: LongInt): string;
  //     
  function SiFindFieldFromSQL(AText, AFieldAlias: string): string;
  //      ORDER BY  GROUP BY
  function SiInsertBeforeOrderBy(ASQL, AString: string): string;
  //       
  //     [.NAME]
  function SiChangeTextFromDataSet(ADataSet: TDataSet; ADataSetName, AText: string): string;
  //    
  function SiDropQuotes(AString: string): string;
  //    
  // ADataSet -  , AFieldsStr -  , AFieldsDelemeter  AValuessDelemeter - 
  function SiGetManyValuesFromDataSet(ADataSet: TDataSet; AFieldsStr: string; AFieldsDelemeter, AValuesDelemeter: Char): string;
  // ,   ,        
  function SiPosN(APart, AString: string): LongInt;
  //      
  function SiExtractHostByPath(APath: string): string;
  //       
  function SiGetComputerNetName: string;
  //   
  function SiFindFiles(APath: string; AList: TStrings): Boolean;
  //     
  function SiReplaceQuotationMark(AString: string): String;
  //       
  function SiDeleteDirectory(const ADirectoryName: string): Boolean;
  // ,      SQL-
  function SiIsSQLFieldNotSimple(AField: string): Boolean;
  //     
  function SiFieldTypeToStr(AFieldType: TFieldType): string;
  //     
  function SiStrToFieldType(const AStr: string): TFieldType;
  //    BDE
  function SiBDEExists: Boolean;
  //     AFileName   ,
  //  C:\Temp\picture.jpg D:\New\ => D:\New\picture.jpg
  // .      ,      
  function SiReplacePath(AFileName, APath: string): string;
  //    
  function SiGetTempDir: string;
  //    ApplicationData
  function SiGetApplicationData: string;
  //    ApplicationData
  { user\Local Settings\Application Data }
  function SiGetLocalApplicationData: string;
  //    ApplicationData
  { All Users\Application Data }
  function SiGetCommonApplicationData: string;
  //     
  function GetFullVersion: string;
  //     
  function GetSmallVersion: string;
  //    
  function GetDateCompile: TDateTime;
  //       
  procedure GetRegisteredProvidersList(AList: TStrings;
    const AFindKey, AFindName, AFindValue: WideString);
  //    - AMemo -  AFindTExt -   ALastPosition -  
  function SiFindTextInMemo(AMemo: TCustomMemo; var AFindTExt: string; var ALastPosition: LongInt): Boolean;
  //  
  procedure SiPaintRichWord(ARich: TRichEdit; AWord: string; var APosition: LongInt; AColor: TColor);
  //  
  procedure SiClearRichWord(ARich: TRichEdit; AColor: TColor);

implementation

{$R SiIcons.RES}

uses
  SiIniFile, SiComboEdit, ShlObj;

function MakeSQLOrder(ASQLText, AFieldName: string): string;
var
  xPos: LongInt;
  xOrderString: string;
  xSQLText: string;
begin
  xOrderString := SIUTILS_ORDER_BY + ' ' + AFieldName;
  xPos := Pos(SIUTILS_ORDER_BY, ANSIUpperCase(ASQLText));
  if xPos > 0 then
    xSQLText := Copy(ASQLText, 1, xPos - 1)
  else
    xSQLText := ASQLText;
  if AFieldName <> '' then
    xSQLText := xSQLText + ' ' + xOrderString;
  Result := xSQLText;
end;

function MakeSQLOrderByNumber(ASQLText: string; AFieldNumber: LongInt): string;
var
  xPos: LongInt;
  xOrderString: string;
  xSQLText: string;
begin
  xOrderString := SIUTILS_ORDER_BY + ' ' + IntToStr(AFieldNumber + 1); //    1
  xPos := Pos(SIUTILS_ORDER_BY, ANSIUpperCase(ASQLText));
  if xPos > 0 then
    xSQLText := Copy(ASQLText, 1, xPos - 1)
  else
    xSQLText := ASQLText;
  if AFieldNumber > 0 then
    xSQLText := xSQLText + ' ' + xOrderString;
  Result := xSQLText;
end;


//      
function DaysPerMonth(AYear, AMonth: Integer): Integer;
const
  DaysInMonth: array[1..12] of Integer = (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
  function IsLeapYear(AYear: Integer): Boolean;
  begin
    Result := (AYear mod 4 = 0) and ((AYear mod 100 <> 0) or (AYear mod 400 = 0));
  end;
begin
  Result := DaysInMonth[AMonth];
  if (AMonth = 2) and IsLeapYear(AYear) then Inc(Result); { leap-year Feb is special }
end;

//     APartTwo  APartOne
function CompareParts(APartOne, APartTwo: Variant; ASign: TSign): Boolean;
begin
  if VarType(APartOne) = varDate then
    APartTwo := VarToDateTime(APartTwo);
  Result := false;
  try
    case ASign of
      snEqual:       Result := (APartOne = APartTwo);
      snGreater:     Result := (APartOne > APartTwo);
      snLess:        Result := (APartOne < APartTwo);
      snNotEqual:    Result := (APartOne <> APartTwo);
      snInside:      Result := ( Pos(APartTwo, APartOne) > 0);
      snInsideLeft:  Result := ( Pos(APartTwo, APartOne) = 1);
      snInsideRifgt: Result := ( ( Pos(APartTwo, APartOne) + length(APartTwo) ) = length(APartOne) +1 );
    end;
  except end;
end;

function FieldByGridCaption(AColumns: TDBGridColumns; ACaption: string): string;
var
  i: LongInt;
begin
  Result := SIUTILS_NOT_FOUND;
  for i := 0 to AColumns.Count - 1 do
    if ACaption = AColumns[i].Field.DisplayName then
      Result := AColumns[i].FieldName;
end;

function FieldNumberByGridCaption(AGrid: TDbGrid; xCaption: string): LongInt;
var
  i: LongInt;
begin
  Result := SIUTILS_NUMBER_NOT_FOUND;
  //   
  for i := 0 to AGrid.Columns.Count - 1 do
    if xCaption = AGrid.Columns[i].Field.DisplayName then
      Result := AGrid.Columns[i].Field.FieldNo;
end;

function FieldByCaption(AFields: TFields; ACaption: string): TField;
var
  i: LongInt;
begin
  Result := nil;
  with AFields do
    for i := 0 to Count - 1 do
      if ACaption = Fields[i].DisplayName then
        Result := Fields[i];
end;

procedure FillDBStrings(AStrings: TStrings; APlatform: TDataTechnology; AAlias, ATable, AFieldName :string);
var
  xSQLText: string;
  xQuery: TQuery;
//  xADOQuery: TADOQuery;
begin
  xSQLText := 'SELECT ' + AFieldName + ' AS VALUE ' +
              'FROM ' + ATable + ' ' +
              'GROUP BY ' + AFieldName;
  // -----------------  BDE --------------------------------------------
  xQuery := TQuery.Create(Application);
  with xQuery do
  begin
    DatabaseName := AAlias;
    SQL.Text := xSQLText;
    Open;
    First;
    while not Eof do
    begin
      AStrings.Add(FieldByName('Value').AsString);
      Next;
    end;
    Close;
    Free;
  end;
 { // -----------------  ADO --------------------------------------------
  xADOQuery := TADOQuery.Create(Application);
  with xADOQuery do
  begin
    ConnectionString := AAlias;
    SQL.Text := xSQLText;
    Open;
    First;
    while not Eof do
    begin
      AStrings.Add(FieldByName('Value').AsString);
      Next;
    end;
    Close;
    Free;
  end;   }
end;

function YesNo(Value: string): boolean;
begin
  Result := Application.MessageBox( PChar(Value), PChar(Application.Title), MB_OKCANCEL or MB_ICONQUESTION) = IDOK;
end;

function YesNoCancel(Value: string): integer;
begin
  Result := Application.MessageBox( PChar(Value), PChar(Application.Title), MB_YESNOCANCEL or MB_ICONQUESTION);
end;

function SiIntToExcelLetter(Value: LongInt): string;
begin
  Result := '';
  case Value of
    1:  Result := 'A';
    2:  Result := 'B';
    3:  Result := 'C';
    4:  Result := 'D';
    5:  Result := 'E';
    6:  Result := 'F';
    7:  Result := 'G';
    8:  Result := 'H';
    9:  Result := 'I';
    10: Result := 'J';
    11: Result := 'K';
    12: Result := 'L';
    13: Result := 'M';
    14: Result := 'N';
    15: Result := 'O';
    16: Result := 'P';
    17: Result := 'Q';
    18: Result := 'R';
    19: Result := 'S';
    20: Result := 'T';
    21: Result := 'U';
    22: Result := 'V';
    23: Result := 'W';
    24: Result := 'X';
    25: Result := 'Y';
    26: Result := 'Z';
    27: Result := 'AA';
    28: Result := 'AB';
    29: Result := 'AC';
    30: Result := 'AD';
    31: Result := 'AE';
    32: Result := 'AF';
    33: Result := 'AG';
    34: Result := 'AH';
    35: Result := 'AI';
    36: Result := 'AJ';
    37: Result := 'AK';
    38: Result := 'AL';
    39: Result := 'AM';
    40: Result := 'AN';
    41: Result := 'AO';
    42: Result := 'AP';
    43: Result := 'AQ';
    44: Result := 'AR';
    45: Result := 'AS';
    46: Result := 'AT';
    47: Result := 'AU';
    48: Result := 'AV';
    49: Result := 'AW';
    50: Result := 'AX';
    51: Result := 'AY';
    52: Result := 'AZ';
  end;
end;

function SiExcelColFromLetter(ACell: string): LongInt;
var
  xFirstLetter, xSecondLetter: string;
  xFirstNum, xSecondNum: LongInt;
begin
  Result := 0;
  //  
  xFirstLetter  := Copy(ACell, 1, 1);
  xFirstNum := SiLetterNumber(xFirstLetter);
  //  
  xSecondLetter := Copy(ACell, 2, 1);
  xSecondNum := SiLetterNumber(xSecondLetter);
  //    ,   
  if xSecondNum > 0 then
    Result := xFirstNum * 26 + xSecondNum;
  //    ,    
  if xSecondNum = 0 then
    Result := xFirstNum ;
end;

function SiLetterNumber(ALetter: string): LongInt;
begin
  Result := 0;
  //    
  if ALetter = 'A' then Result := 1;
  if ALetter = 'B' then Result := 2;
  if ALetter = 'C' then Result := 3;
  if ALetter = 'D' then Result := 4;
  if ALetter = 'E' then Result := 5;
  if ALetter = 'F' then Result := 6;
  if ALetter = 'G' then Result := 7;
  if ALetter = 'H' then Result := 8;
  if ALetter = 'I' then Result := 9;
  if ALetter = 'J' then Result := 10;
  if ALetter = 'K' then Result := 11;
  if ALetter = 'L' then Result := 12;
  if ALetter = 'M' then Result := 13;
  if ALetter = 'N' then Result := 14;
  if ALetter = 'O' then Result := 15;
  if ALetter = 'P' then Result := 16;
  if ALetter = 'Q' then Result := 17;
  if ALetter = 'R' then Result := 18;
  if ALetter = 'S' then Result := 19;
  if ALetter = 'T' then Result := 20;
  if ALetter = 'U' then Result := 21;
  if ALetter = 'V' then Result := 22;
  if ALetter = 'W' then Result := 23;
  if ALetter = 'X' then Result := 24;
  if ALetter = 'Y' then Result := 25;
  if ALetter = 'Z' then Result := 26;
end;


function SiExcelRowFromLetter(ACell: string): LongInt;
var
  xColStr: string;
  xLetter: string;
begin
  //   
  xLetter := Copy(ACell, 2, 1);
  //    
  if SiLetterNumber(xLetter) = 0 then
    xColStr := Copy(ACell, 2, Length(ACell) - 1);
  //    
  if SiLetterNumber(xLetter) > 0 then
    xColStr := Copy(ACell, 3, Length(ACell) - 1);
  //    
  Result := StrToInt(xColStr);
end;

function AppPath: string;
var
  xAppName: string;
begin
  xAppName := ANSIUpperCase(Application.ExeName);
  Result := ExtractFilePath(xAppName);
end;

function SiCutWord(var ASource: string; const Border: char): string;
var
  xPos: integer;
begin
  xPos := pos(Border, ASource);
  if xPos > 0 then
  begin
    Result := copy(ASource, 1, xPos - 1);
    System.Delete(ASource, 1, xPos);
  end
  else
  begin
    Result := ASource;
    System.Delete(ASource, 1, length(ASource));
  end;
  Result := trim(Result);
end;

function SiChangeWord(ASource: string; OldWord, NewWord: string): string;
var
  xPos: integer;
begin
  Result := ASource;
  xPos := Pos(OldWord, ASource);
  if xPos > 0 then
  begin
    Delete(Result, xPos, Length(OldWord));
    Insert(NewWord, Result, xPos)
  end;
end;

//       ()
function SiChangeWordN(const ASource, OldWord, NewWord: string): string;
var xPos: Integer;
begin
  Result := ASource;
  xPos := Pos(UpperCase(OldWord), UpperCase(ASource));
  if (xPos>0) then
  begin
    Delete(Result, xPos, Length(OldWord));
    Insert(NewWord, Result, xPos);
  end;
end;

function SiChangeWords(ASource: string; OldWord, NewWord: string): string;
begin
  Result := ASource;
  while Pos(OldWord, Result) > 0 do
    Result := SiChangeWord(Result, OldWord, NewWord);
end;

//        ()
function SiChangeWordsN(const ASource, OldWord, NewWord: string): string;
var xPos: Integer;
begin
  Result := ASource;
  xPos := Pos(UpperCase(OldWord), UpperCase(ASource));
  while (xPos>0) do
  begin
    Delete(Result, xPos, Length(OldWord));
    Insert(NewWord, Result, xPos);
    xPos := Pos(UpperCase(OldWord), UpperCase(Result));
  end;
end;

function SiIsAlpha(Value: Char): Boolean;
begin
  Result := (Value in ['a'..'z', 'A'..'Z', ''..'', ''..'', '0'..'9']);
end;

function SiIniFileName: string;
begin
  Result := ANSIUpperCase(Application.ExeName);
  Result := SiChangeWord(Result, '.EXE', '.INI');
end;

function SiFieldExists(ADataSet: TDataSet; AFieldName: string): Boolean;
var
  i: LongInt;
  xFieldName: string;
begin
  Result := false;
  xFieldName := ANSIUpperCase(trim(AFieldName));
  with ADataSet do
    for i := 0 to Fields.Count - 1 do
      if xFieldName = ANSIUpperCase(trim(Fields[i].FieldName)) then
      begin
        Result := true;
        Exit;
      end;
end;

function SiInteger(AStr: string; ADefault: LongInt): LongInt;
begin
  Result := StrToIntDef(AStr, ADefault);
end;

function ExtractYear(ADate: TDateTime): Word;
var
  Year, Month, Day: Word;
begin
  DecodeDate(ADate, Year, Month, Day);
  Result := Year;
end;

function ExtractMonth(ADate: TDateTime): Word;
var
  Year, Month, Day: Word;
begin
  DecodeDate(ADate, Year, Month, Day);
  Result := Month;
end;

function ExtractDay(ADate: TDateTime): Word;
var
  Year, Month, Day: Word;
begin
  DecodeDate(ADate, Year, Month, Day);
  Result := Day;
end;

function SiManyStrings(AString: string; ACount: LongInt): string;
var
  i: LongInt;
begin
  Result := '';
  for i := 0 to ACount - 1 do
    Result := Result + AString;
end;

function SiConnectDataBase(AAlias, ALogin, APassword: string): TDatabase;
var
  xDataBase: TDataBase;
  i: LongInt;
begin
  for i := 0 to Session.DatabaseCount - 1 do
    if Session.Databases[i].DatabaseName = AAlias then
    begin
      Result := nil;
      Exit;
    end;
  xDataBase := TDatabase.Create(Application);
  with xDataBase do
  begin
    DatabaseName := AAlias;
    LoginPrompt := false;
    Params.Clear;
    Params.Add('USER NAME=' + trim(ALogin));
    Params.Add('PASSWORD=' + trim(APassword));
    try
      Connected := true;
    except end;
  end;
  Result := xDataBase;
end;

function SiChangeAliasParam(AAlias, AParamName, AValue: string): Boolean;
var
  i: LongInt;
  xParams: TStringList;
  xParamName: string;
begin
  Result := false;
  xParamName := AParamName + '=';
  xParams := TStringList.Create;
  //      
  Session.GetAliasParams(AAlias,xParams);
  //      
  for i := 0 to xParams.Count - 1 do
    if pos(xParamName, xParams[i]) = 1 then
    begin
      xParams[i] := xParamName + AValue;
      Result := true;
    end;
  //   
  if Result then
    Session.ModifyAlias(AAlias,xParams);
  xParams.Free;
end;

procedure SiFormatFloatField(ADataSet: TDataSet; AField: string; ANumber: byte);
var
  xField: TField;
  s: string;
  i: byte;
begin
  xField := ADataSet.Fields.FieldByName(AField);
  s := '';
  for i:=1 to ANumber do
    s := s + '0';
  if s <> '' then s := '.' + s;
  if (xField is TNumericField) then
    TFloatField(xField).DisplayFormat := ',#0' + s;
end;

procedure SiMakeStringsSameLength(ASample, AStrings: TStrings);
begin
  //       
  while ASample.Count > AStrings.Count do
   AStrings.Add('');
  //  ,     
  while ASample.Count < AStrings.Count do
   AStrings.Delete(AStrings.Count - 1);
end;

function SiSwitchOn(AString, ASwitch: string): Boolean;
var
  xSwitch, xString: string;
begin
  Result := false;
  xSwitch := trim(ANSIUppercase(ASwitch));
  xString := trim(ANSIUppercase(AString));
  if Pos(xSwitch, xString) > 0 then
    Result := true;
end;

function SiSwitchParam(AString, ASwitch: string; AParamNo: LongInt): string;
var
  xPos, i: LongInt;
  xSwitch, xString: string;
begin
  Result := '';
  xSwitch := trim(ANSIUppercase(ASwitch));
  xString := trim(ANSIUppercase(AString));
  xPos := Pos(xSwitch, xString);
  if xPos > 0 then
  begin
    xString := SiCutWord(AString, SIDATAINPUT_SWITCH_SEPARATOR);
    xString := Copy(xString, xPos + length(ASwitch), length(xString));
    for i := 0 to AParamNo do
      Result := SiCutWord(xString, SIDATAINPUT_WINDOW_PARAM_SEPARATOR);
  end;
end;

function SiStrToLatin(AString: string): string;
var
  i: LongInt;
  xChar: string;
begin
  Result := '';
  for i := 1 to length(AString) do
  begin
    xChar := Copy(AString, i, 1);
    // FIRST LINE OF KEYBOARD
    if xChar = '' then xChar := 'Q';
    if xChar = '' then xChar := 'W';
    if xChar = '' then xChar := 'E';
    if xChar = '' then xChar := 'R';
    if xChar = '' then xChar := 'T';
    if xChar = '' then xChar := 'Y';
    if xChar = '' then xChar := 'U';
    if xChar = '' then xChar := 'I';
    if xChar = '' then xChar := 'O';
    if xChar = '' then xChar := 'P';
    if xChar = '' then xChar := '[';
    if xChar = '' then xChar := ']';
    // SECOND LINE OF KEYBOARD
    if xChar = '' then xChar := 'A';
    if xChar = '' then xChar := 'S';
    if xChar = '' then xChar := 'D';
    if xChar = '' then xChar := 'F';
    if xChar = '' then xChar := 'G';
    if xChar = '' then xChar := 'H';
    if xChar = '' then xChar := 'J';
    if xChar = '' then xChar := 'K';
    if xChar = '' then xChar := 'L';
    if xChar = '' then xChar := ';';
    if xChar = '' then xChar := '''';
    // THIRD LINE OF KEYBOARD
    if xChar = '' then xChar := 'Z';
    if xChar = '' then xChar := 'X';
    if xChar = '' then xChar := 'C';
    if xChar = '' then xChar := 'V';
    if xChar = '' then xChar := 'B';
    if xChar = '' then xChar := 'N';
    if xChar = '' then xChar := 'M';
    if xChar = '' then xChar := ',';
    if xChar = '' then xChar := '.';
    if xChar = '.' then xChar := '/';
    Result := Result + xChar;
  end;
end;

function SiComputerName: string;
var
  xSocket: TServerSocket;
begin
  Result := SIUTILS_HOST_NOT_DETECTED;
  xSocket := TServerSocket.Create(Application);
  try
     xSocket.Open;
     Result := xSocket.Socket.LocalHost;
     xSocket.Close;
  finally
     xSocket.Free;
  end;
end;

procedure SiCopyDataSetToADOTable(ADataSet: TDataSet; AConnectionString: string;
  ATableName: string; ACreateFlag: Boolean);
//var
//  xADOTable: TADOTable;
//  xADODataSet: TADODataSet;
//  xField: TField;
//  i: LongInt;
begin
{   . -  ! 
  xADODataSet := TADODataSet.Create(nil);
  xADODataSet.ConnectionString := AConnectionString;
  xADODataSet.CursorType := ctDynamic;
  xADODataSet.CommandText := 'SELECT * FROM ' + ATableName;
  with xADODataSet.FieldDefs do
  begin
    Clear;
    for i := 0 to ADataSet.Fields.Count - 1 do
    begin
      xField := ADataSet.Fields[i];  //     
      Add(xField.FieldName, xField.DataType, xField.Size, False)
    end;
  end;
  xADODataSet.CreateDataSet;
  xADODataSet.Free;    }
end;

procedure SiAddSlash(var AString: string);
var
  xString, xLastSymbol: string;
begin
  xString := trim(AString);
  xLastSymbol := Copy(xString, Length(xString), 1);
  if (xLastSymbol <> SIUTILS_SLASH) then
    xString := xString + SIUTILS_SLASH;
  AString := xString;
end;

function SiFusionDll(ADLLName, AFuntionName: string; AFusionParam: TFusionParam): Boolean;
var
   //   
   xFusion_Function:  function(AFusionParam: TFusionParam): Boolean;
   xDllHandle :Integer;
begin
  Result := false;
  @xFusion_Function := nil;
  xDllHandle := LoadLibrary(PChar(ADLLName));
  if xDllHandle < 32 then
  begin
    AFusionParam.Error := 'dll   ' + AFuntionName;
    Exit;
  end;
  //  
  @xFusion_Function       := GetProcAddress(xDllHandle, PChar(AFuntionName));
  // ,    
  if (@xFusion_Function = nil) then
        AFusionParam.Error := format(SIUTILS_METHODINDD_NOTFOUND, [AFuntionName, ADLLName])
  else
    Result := xFusion_Function(AFusionParam);
{     .     
  if xDllHandle <> 0 then
    FreeLibrary(xDllHandle);}
end;

procedure SiCopyClientDataSet(AClientDataSetFrom, AClientDataSetTo: TClientDataSet);
var
  i: LongInt;
  xFieldName, xString: string;
begin
  //  
  AClientDataSetTo.Active := false;
  AClientDataSetTo.FieldDefs.Clear;
  for i := 0 to AClientDataSetFrom.FieldDefs.Count - 1 do
    with AClientDataSetTo.FieldDefs.AddFieldDef do
    begin
      Name := AClientDataSetFrom.FieldDefs[i].Name;
      DataType := AClientDataSetFrom.FieldDefs[i].DataType;
      Size := AClientDataSetFrom.FieldDefs[i].Size;
      Required := AClientDataSetFrom.FieldDefs[i].Required;
    end;
  AClientDataSetTo.CreateDataSet;
  AClientDataSetTo.Active := true;
  //  
  with AClientDataSetFrom do
  begin
    First;
    while not Eof do
    begin
      AClientDataSetTo.Append;
      for i := 0 to AClientDataSetTo.Fields.Count - 1  do
      begin
        xFieldName := Fields[i].FieldName;
        xString := FieldByName(xFieldName).AsString;
        AClientDataSetTo.Fields[i].AsString := xString;
      end;
      AClientDataSetTo.Post;
      Next;
    end;
  end;
end;

function SiParameterByName(AParamName, AString: string): string;
var
  xString, xLine: string;
  xParamName: string;
begin
  xString := AString;
  repeat
    xLine := SiCutWord(xString, ';');
    xParamName := SiCutWord(xLine, '=');
    if ANSIUpperCase(AParamName) = ANSIUpperCase(xParamName) then
      Result := xLine;
  until xString = '';
end;

function SiCalculateLetterWidth(AFont: TFont): LongInt;
var
  xString, xString1, xString2, xString3, xString4, xString5: string;
  xCount: LongInt;
  xLabel: TLabel;
begin
  xString1 := '.'; // 32
  xString2 := '.'; // 32
  xString3 := 'qwertyuiop[]asdfghjkl; zxcvbnm,./'; // 32
  xString4 := 'QWERTYUIOP[]ASDFGHJKL; ZXCVBNM,./'; // 32
  xString5 := '123456789~!@#$%^&*()_+|';           // 23
  xString := xString1 + xString2 + xString3 + xString4 + xString5;
  xCount := 32 + 32 + 32 + 32 + 23;
  xLabel := TLabel.Create(Application);
  xLabel.Visible := false;
  xLabel.Font :=  AFont;
  xLabel.Caption := xString;
  Result := Ceil(xLabel.Width / xCount);
  xLabel.Free;
end;

function SiCopyFilePart(AFileFrom, AFileTo, ABeginStr, AEndStr: string; ACutReturnChar: Boolean): Boolean;
var
  xStreamFrom, xStreamTo: TFileStream;
  xStartPosition, xEndPosition: LongInt;
begin
  Result := True;
  xStreamFrom  := TFileStream.Create(AFileFrom, fmOpenRead);
  //    
  xStartPosition := SiFindStreamPosision(xStreamFrom, ABeginStr);
  xEndPosition   := SiFindStreamPosision(xStreamFrom, AEndStr);
  if (xStartPosition >= 0) and (xEndPosition >= 0) then
  begin
    //      
    xStartPosition := xStartPosition + Length(ABeginStr);
    //        
    if ACutReturnChar then
      xStartPosition := xStartPosition + 2;
    //   
    xStreamFrom.Seek(xStartPosition, 0);
    //    
    xStreamTo := TFileStream.Create(AFileTo, fmCreate);
    if xEndPosition <> xStartPosition then  //   ,  
      xStreamTo.CopyFrom(xStreamFrom, xEndPosition - xStartPosition);
    xStreamTo.Free;
  end;
  xStreamFrom.Free;
end;

//    ShowMessage(' ' + IntToStr(xStartPosition));
//    ShowMessage('  ' + IntToStr(xEndPosition));

function SiFindStreamPosision(AFileStream: TFileStream; AString: string): LongInt;
var
  xBString: string;
  xBusffer: array[0..100] of Char;
  xLength, xFileLength, i: longInt;
begin
  xLength := Length(AString);
  xFileLength := AFileStream.Size;
  i := 0;
  Result := -1;
  AFileStream.Seek(0, 0);
  while (i <  xFileLength -1) and (Result < 0) do
  begin
    AFileStream.Seek(i, 0);
    AFileStream.Read(xBusffer, xLength);
    xBString := trim(StrPas(xBusffer));
    xBString := copy(xBString, 0, xLength);
    if (AString = xBString) then
      Result := i;
    i := i + 1;
  end;
end;

//  
// aExt  -   3  (NNW)
// aApp  -     (c:\nnw\nnw.exe)
// aName -    ,  (NeuralNetworkWizardFile)
// aIconMun -   .
procedure SiSetAppExtention(AExtName, AAppName: string);
var
  xReg : TRegistry;
  xStr : string;
begin
  xReg := TRegistry.Create;
  try
    xReg.RootKey:= HKEY_CLASSES_ROOT;
    xStr := '\.'+ AExtName;
    if xReg.OpenKey(xStr, true) then
    begin
      xReg.WriteString('', AAppName);
      xReg.CloseKey;
      xStr := '\' + AAppName ;
      if xReg.OpenKey(xStr, true) then
      begin
        xReg.WriteString('', AAppName + ' File');
        xReg.CloseKey;
        //  
        xStr := '\' + AAppName + '\DefaultIcon';
        if xReg.OpenKey(xStr, true) then
        begin
          xStr := Application.ExeName + ',' + '1';
          xReg.WriteString('', xStr);
          xReg.CloseKey;
        end;
      end;

      xStr := '\' + AAppName + '\shell\open\command';
      if xReg.OpenKey(xStr, true) then
      begin
        xStr := '"'+ Application.ExeName + '" "%1"' ;
        xReg.WriteString('', xStr);
        xReg.CloseKey;
      end;
  end;    
  finally
    xReg.Free;
  end;
end;

function SiIsFilterOk(ADataSet: TDataSet): Boolean;
var
  xDataSet: TClientDataSet;
  i: LongInt;
begin

  xDataSet := TClientDataSet.Create(nil);
  xDataSet.FieldDefs.Clear;
  for i := 0 to ADataSet.FieldCount - 1 do
    with xDataSet.FieldDefs.AddFieldDef do
    begin
      Name := ADataSet.Fields[i].FieldName;
      Required  := false;
      DataType  := ADataSet.Fields[i].DataType;
      Size      := ADataSet.Fields[i].Size;
      FieldNo   := ADataSet.Fields[i].FieldNo;
    end;
  xDataSet.CreateDataSet;
  //  
  xDataSet.Insert;
  for i := 0 to ADataSet.FieldCount - 1 do
    xDataSet.Fields[i].Value := ADataSet.Fields[i].Value;
  xDataSet.Post;
  // 
  xDataSet.Filter := ADataSet.Filter;
  xDataSet.Filtered := ADataSet.Filtered;
  // ,  
  Result := not (xDataSet.RecordCount = 0);
  //   
  xDataSet.Free;
end;

//    
// , xValue := SiAPIFreeSpace('C:')
//  xValue := SiAPIFreeSpace('\\Server\InterBaseData\')
function SiAPIFreeSpace(AResource: string): Int64;
var
  xFreeBytesAvailableToCaller : Int64;
  xFreeSize     : Int64;
  xTotalSize    : Int64;
begin
  GetDiskFreeSpaceEx( PChar(AResource),
                      xFreeBytesAvailableToCaller,
                      xTotalsize,
                      @xFreeSize );
  Result := xFreeSize;
end;

//        
// AAliasName -  
function SiGetAliasInfo(const AAliasName: string): TAliasInfo;
var List: TStringList;
    i: Integer;
begin
  List := TStringList.Create;
  Session.GetAliasParams(AAliasName, List);
  Result.Name := AAliasName;
  Result.Driver := Session.GetAliasDriverName(AAliasName);
  Result.Server := '';
  Result.User := '';
  Result.Path := '';
  Result.Default := '';  
  for i:=0 to List.Count-1 do
  begin
    if(Pos(ALIAS_SERVER_NAME, List[i])>0) then
      Result.Server := Copy(List[i], Pos('=', List[i])+1, Length(List[i])-Pos('=', List[i]));
    if(Pos(ALIAS_USER_NAME, List[i])>0) then
      Result.User := Copy(List[i], Pos('=', List[i])+1, Length(List[i])-Pos('=', List[i]));
    if(Pos(ALIAS_PATH, List[i])>0) then
      Result.Path := Copy(List[i], Pos('=', List[i])+1, Length(List[i])-Pos('=', List[i]));
    if(Pos(ALIAS_DEFAULT_DRIVER, List[i])>0) then
      Result.Default := Copy(List[i], Pos('=', List[i])+1, Length(List[i])-Pos('=', List[i]));
  end;
  List.Free;
end;

//   ini   
// AFileName  -  
// ASection   -  
// AAliasList -  
procedure SiBDEParamWrite(const AFileName: string; const ASection: string; const AAliasList: TStringList);
var Ini: TIniFile;
    i: Integer;
    xAliasInfo: TAliasInfo;
begin
  Ini := TIniFile.Create(AFileName);
  try
    Ini.EraseSection(ASection);
    Ini.WriteInteger(ASection, INI_ALIAS_COUNT, AAliasList.Count);
    for i:=0 to AAliasList.Count-1 do
    try
      begin
        xAliasInfo := SiGetAliasInfo(AALiasList[i]);
        Ini.WriteString(ASection, INI_ALIAS_NAME + IntToStr(i), xAliasInfo.Name);
        Ini.WriteString(ASection, INI_ALIAS_DRIVER + IntToStr(i), xAliasInfo.Driver);
        Ini.WriteString(ASection, INI_ALIAS_SERVER + IntToStr(i), xAliasInfo.Server);
        Ini.WriteString(ASection, INI_ALIAS_USER + IntToStr(i), xAliasInfo.User);
        Ini.WriteString(ASection, INI_ALIAS_PATH + IntToStr(i), xAliasInfo.Path);
        Ini.WriteString(ASection, INI_ALIAS_DEFAULT + IntToStr(i), xAliasInfo.Default);
      end;
    except end;  
  finally
    Ini.Free;
  end;
end;

function SiAddPathSlash(APath: string): string;
var
  xLenght: LongInt;
  xLastSimbol: string;
begin
  xLenght := Length(APath);
  xLastSimbol := Copy(APath, xLenght, 1);
  if (xLastSimbol = '\') or (xLastSimbol = '/') then
    Result := APath
  else
    Result := APath + '\';
end;

procedure SiSaveGridColumns(ADBGrid: TDBGrid; AStrings: TStrings);
var
  i, j, xWidth, xOrder: LongInt;
  xVisibleStr, xFieldName, xString: string;
begin
  //  -  ,   
  if (( not Assigned(ADBGrid)) or
      ( not Assigned(ADBGrid.DataSource)) or
      ( not Assigned(ADBGrid.DataSource.DataSet))) then
    Exit;
  AStrings.Clear;
  with ADBGrid.DataSource.DataSet do
  begin
   for i :=0 to Fields.Count - 1 do
   begin
     xFieldName := Fields[i].FieldName;
     //    
     xWidth := 10; //   ,   
     for j := 0 to ADBGrid.Columns.Count - 1 do
       if (ADBGrid.Columns[j].FieldName = xFieldName) then
       begin
         xWidth := ADBGrid.Columns[j].Width;
         break;
       end;
     xOrder := i;
     if Fields[i].Visible then
       xVisibleStr := SI_TRUE_VALUE
     else
       xVisibleStr := SI_FALSE_VALUE;
     //        |  |  |  | 
     xString := xFieldName + SIMETA_FIELDS_SEPARATOR;
     xString := xString + Fields[i].DisplayLabel + SIMETA_FIELDS_SEPARATOR;
     xString := xString + IntToStr(xWidth) + SIMETA_FIELDS_SEPARATOR;
     xString := xString + IntToStr(xOrder) + SIMETA_FIELDS_SEPARATOR;
     xString := xString + xVisibleStr;
     // 
     AStrings.Add(xString)
    end;
  end;
end;

procedure SiLoadGridColumns(ADBGrid: TDBGrid; AStrings: TStrings);
var
  i, j: LongInt;
  xString, xFieldName, xCaption, xVisibleStr: string;
  xWidth, xOrder: LongInt;
  xVisible: Boolean;
begin
  if not Assigned(ADBGrid.DataSource.DataSet) then
    Exit;                                                //  19.11.2009
  for i := 0 to AStrings.Count - 1 do
  begin
    xString := AStrings[i];
    while xString <> '' do
    begin
      //      |  |  |  | 
      xFieldName  := SiCutWord(xString, SIMETA_FIELDS_SEPARATOR);
      xCaption    := SiCutWord(xString, SIMETA_FIELDS_SEPARATOR);
      xWidth      := StrToInt(SiCutWord(xString, SIMETA_FIELDS_SEPARATOR));
      xOrder      := StrToInt(SiCutWord(xString, SIMETA_FIELDS_SEPARATOR));
      xVisibleStr := SiCutWord(xString, SIMETA_FIELDS_SEPARATOR);
      xVisible    := (xVisibleStr = SI_TRUE_VALUE);
      if ADBGrid.DataSource.DataSet.FindField(xFieldName) <> nil then
      begin
        //    
        with ADBGrid.DataSource.DataSet.FieldByName(xFieldName) do
        begin
          Index := xOrder;
          Visible := xVisible;
          DisplayLabel := xCaption;
        end;
        for j := 0 to ADBGrid.Columns.Count - 1 do
          if (ADBGrid.Columns[j].FieldName = xFieldName) then
            with ADBGrid.Columns[j] do
            begin
              Width := xWidth;
              break;
             end;
      end;       
    end;
  end;
end;

function SiReplaceStringFromDataSet(AString: string; ADataSet: TDataSet): string;
var
  xIndex: LongInt;
  xString: string;
  xFieldName, xValue: string;
begin
  Result := AString;
  xString := AString;
  while xString <> '' do
  begin
    //   ,  
                  SiCutWord(xString, SIMETA_FIELDREPLACE_LEFT);
    xFieldName := SiCutWord(xString, SIMETA_FIELDREPLACE_RIGHT);
    //    ,      
    if xFieldName <> '' then
    begin
      xFieldName := trim(xFieldName);
      xIndex := ADataSet.FieldDefs.IndexOf(xFieldName);
      if xIndex >= 0 then
      begin
        // xValue := ADataSet.Fields[xIndex].AsString;
        xValue := ADataSet.FieldByName(xFieldName).AsString;
        //    
        Result := StringReplace(Result, SIMETA_FIELDREPLACE_LEFT + xFieldName + SIMETA_FIELDREPLACE_RIGHT, xValue, [rfIgnoreCase]);
      end;
    end;
  end;
end;

//    
function SiGetStringByTags(AString, ATagFrom, ATagTo: string): string;
var
  xBegin, xEnd: LongInt;
begin
  Result := '';
  //     
  xBegin := Pos(ATagFrom, AString);
  xEnd   := Pos(ATagTo, AString);
  //      
  if xEnd > 0 then
    Result  := copy(AString, xBegin + Length(ATagFrom), xEnd - Length(ATagFrom) - 1);
  //  ,    
  if xEnd <= 0 then
    Result  := copy(AString, xBegin + Length(ATagFrom), Length(AString) - Length(ATagFrom));
end;

//    , 
// AString - ,   ; ANewVale -  
// ATagFrom -  ; ATagTo -  
function SiReplaceStringByTags(AString, ANewVale, ATagFrom, ATagTo: string): string;
var
  xBegin, xEnd: LongInt;
  xPart1, xPart2, xPart3: string;
begin
  xBegin := Pos(ATagFrom, AString);
  xEnd   := Pos(ATagTo, AString);
  if (xBegin < 1) or (xEnd < 1) then
    ShowMessage('    .' + ATagFrom + ' ' + ATagTo);
  //    
  xEnd := xEnd + length(ATagTo);
  // 
  xPart1 := copy(AString, 1, xBegin -1);
  xPart2 := ATagFrom + ' ' +  ANewVale + ' ' + ATagTo;
  xPart3 := copy(AString, xEnd, length(Astring) - xEnd - 1);
  // ShowMessage(' 1 ' + xPart1); ShowMessage(' 2 ' + xPart2);  ShowMessage(' 3 ' + xPart3);
  Result := xPart1 + xPart2 + xPart3;
end;

//   Like     
// ACondition = 0,1,2 (  ,   ,   )
// ARegister = 0, 1 (  ,    )
function SiAddSQLLike(ASQLText, AFieldName, AValue: string; ACondition, ARegister: LongInt): string;
var
  xSQLText, xLikeString, xFieldName, xUpperFunction: string;
  xBegin, xEnd: LongInt;
  xLikeExpression: string;
begin
  xUpperFunction := SIMETA_SQL_UPPER_FUNCTION;
  xSQLText := ASQLText;
  case ACondition of
    0: xLikeExpression  := SIMETA_SQL_LIKE_PERCENT + AValue + SIMETA_SQL_LIKE_PERCENT;   //   
    1: xLikeExpression  := AValue +SIMETA_SQL_LIKE_PERCENT;                              //    
    2: xLikeExpression  := AValue;                                                       //   
  end;
  // ,   ,    
  xLikeExpression := SiReplaceQuotationMark(xLikeExpression);
  //    
  xLikeExpression := SIUTILS_QUOTE_SINGLE + xLikeExpression + SIUTILS_QUOTE_SINGLE;
  //   
  case ARegister of
    0: xLikeExpression := xLikeExpression;
    1: xLikeExpression := SIMETA_SQL_UPPER_FUNCTION + '(' + xLikeExpression + ')';
  end;
  case ACondition of
    0: xLikeExpression  := SIMETA_SQL_LIKE  + ' ' + xLikeExpression;
    1: xLikeExpression  := SIMETA_SQL_LIKE  + ' ' + xLikeExpression;
    2: xLikeExpression  := SIMETA_SQL_EQUAL + ' ' + xLikeExpression;
  end;
  //   
  case ARegister of
    0: xFieldName := AFieldName;
    1: xFieldName := SIMETA_SQL_UPPER_FUNCTION + '(' + AFieldName + ')';
  end;
 // C  LIKE
  xLikeString := SIMETA_SQL_AND + ' ' +
                 xFieldName + ' ' +
                 xLikeExpression;
  // ,   ,  ,     
  xBegin := Pos(SIMETA_SQL_LIKE_BEGIN, xSQLText);
  xEnd   := Pos(SIMETA_SQL_LIKE_END, xSQLText);
  if (xBegin < 1) or (xEnd < 1) then
    xSQLText := SiInsertBeforeOrderBy(xSQLText, ' ' + SIMETA_SQL_LIKE_BEGIN + ' ' + SIMETA_SQL_LIKE_END);
  //   
  if AValue <> '' then
    //   SQL
    xSQLText := SiReplaceStringByTags(xSQLText, xLikeString, SIMETA_SQL_LIKE_BEGIN, SIMETA_SQL_LIKE_END)
  else
    //    ,    LIKE-
    xSQLText := SiReplaceStringByTags(xSQLText, '', SIMETA_SQL_LIKE_BEGIN, SIMETA_SQL_LIKE_END);
  Result := xSQLText;
end;

//       ,    
function SiFindFieldFromSQL(AText, AFieldAlias: string): string;
var
  xFieldAliasString: string;
  //xStartPos,
  xEndPos, xSelectLen: LongInt;
  xSring, xPart: string;
begin
  Result := AFieldAlias;
  xFieldAliasString := SIMETA_SQL_AS + ' ' + AFieldAlias;
  xEndPos := Pos(xFieldAliasString, AText);
  if xEndPos > 0 then
  begin
    xSring := copy(AText, 1, xEndPos - 1);
    while xSring <> '' do
    begin
      //       AS
      xPart := SiCutWord(xSring, SIMETA_SQL_FIELDSCOMA);
      //      SELECT
      xPart := trim(xPart);
      xSelectLen := Length(SIMETA_SQL_SELECT);
      if Pos(SIMETA_SQL_SELECT, xPart) = 1 then
        xPart := Copy(xPart, xSelectLen + 1, Length(xPart) - xSelectLen);
    end;
    // ShowMessage(' : ' + xPart);
    Result := xPart;
  end;
end;

function SiInsertBeforeOrderBy(ASQL, AString: string): string;
var
  xSQL: string;
  xOrederBy_Pos, xGroupBy_Pos: LongInt;
begin
  xSQL := ASQL;
  xOrederBy_Pos := Pos(SIMETA_SQL_ORDERBY, xSQL);
  xGroupBy_Pos  := Pos(SIMETA_SQL_GROUPBY, xSQL);
  //   ,      SQL 
  if (xOrederBy_Pos = 0) and (xGroupBy_Pos = 0) then
    Result := xSQL + AString;
  //  Order By  
  if xGroupBy_Pos > 0 then
    Result := SiChangeWord(xSQL, SIMETA_SQL_GROUPBY, AString + SIMETA_SQL_GROUPBY)
  else
    if xOrederBy_Pos > 0 then
      Result := SiChangeWord(xSQL, SIMETA_SQL_ORDERBY, AString + SIMETA_SQL_ORDERBY);
end;

function SiChangeTextFromDataSet(ADataSet: TDataSet; ADataSetName, AText: string): string;
var
  xText: string;
  xString, xFieldName, xFieldValue: string;
  i, xPos: LongInt;
begin
  xText := AText;
  //      ,   
  if not Assigned(ADataSet) or (not ADataSet.Active) then
  begin
    Result := AText;
    Exit;
  end;
  with ADataSet do
  begin
    xString := SIMETA_FIELDREPLACE_LEFT + ADataSetName;
    xPos := Pos(xString, AText);
    //   -    
    if xPos > 0 then
      //       
      for i := 0 to Fields.Count - 1 do
      begin
        xFieldName := Fields[i].FieldName;
        xFieldValue := Fields[i].AsString;
        xString := SIMETA_FIELDREPLACE_LEFT + ADataSetName + SIMETA_FIELDNAME_SEPARATOR+
                   xFieldName +   SIMETA_FIELDREPLACE_RIGHT;
        xText := SiChangeWord(xText, xString, xFieldValue);
      end;
  end;
  Result := xText
end;

function SiDropQuotes(AString: string): string;
var
  xString, xFirst, xLast: string;
begin
  Result := AString;
  xString := trim(AString);
  xFirst := Copy(xString, 1, 1);
  xLast  := Copy(xString, Length(xString), 1);
  if (xFirst = SIUTILS_QUOTE_SINGLE) and (xLast = SIUTILS_QUOTE_SINGLE) then
    Result :=  Copy(xString, 2, Length(xString) - 2);
  if (xFirst = SIUTILS_QUOTE_DOUBLE) and (xLast = SIUTILS_QUOTE_DOUBLE) then
    Result :=  Copy(xString, 2, Length(xString) - 2);
end;

function SiGetManyValuesFromDataSet(ADataSet: TDataSet; AFieldsStr: string; AFieldsDelemeter, AValuesDelemeter: Char): string;
var
  xFieldsStr, xFieldName: string;
  xFiled: TField;
begin
  Result := '';
  xFieldsStr := AFieldsStr;
  xFieldName := SiCutWord(xFieldsStr, AFieldsDelemeter);
  while xFieldName <> '' do
  begin
    xFiled := ADataSet.FindField(xFieldName);
    if Assigned(xFiled) then
    begin
      if Result <> '' then
        Result := Result + AValuesDelemeter;
      Result := Result + xFiled.AsString;
    end;
    xFieldName := SiCutWord(xFieldsStr, AFieldsDelemeter);
  end;
end;

function SiPosN(APart, AString: string): LongInt;
var
 xPart, xString: string;
begin
  xPart := ANSIUpperCase(APart);
  xString := ANSIUpperCase(AString);
  Result := Pos(xPart, xString);
end;

function SiExtractHostByPath(APath: string): string;
const
  SIUTILS_STRAT_HOSTDELEMETER = '\\';
  SIUTILS_STOP_HOSTDELEMETER  = '\';
var
  xPath: string;
  xPos: LongInt;
begin
  xPath := ExpandUNCFileName(APath);
  //  '\\'
  xPath := Copy(xPath, Length(SIUTILS_STRAT_HOSTDELEMETER) + 1, length(xPath));
  //  '\'
  xPos := Pos(SIUTILS_STOP_HOSTDELEMETER, xPath);
  Result := Copy(xPath, 0, xPos - 1);
end;

function SiGetComputerNetName: string;
var
  buffer: array[0..255] of char;
  size: dword;
begin
  size := 256;
  if GetComputerName(buffer, size) then
    Result := buffer
  else
    Result := ''
end;

function SiFindFiles(APath: string; AList: TStrings): Boolean;
var
  xSearchRecord: TSearchRec;
  xFileAttrs: Integer;
begin
  Result := false;
  xFileAttrs := faDirectory;
  if FindFirst(APath, xFileAttrs, xSearchRecord) = 0 then
  begin
    repeat
      if (xSearchRecord.Name <> '.') and (xSearchRecord.Name <> '..') then 
       AList.Add(xSearchRecord.Name);
    until FindNext(xSearchRecord) <> 0;
    {$WARNINGS OFF}
    FindClose(xSearchRecord.FindHandle);
    {$WARNINGS ON}
    Result := true;
  end;
end;

function SiReplaceQuotationMark(AString: string): String;
var
  i: LongInt;
  xString, xChar: String;
begin
  Result := AString;
    // ,   ,    
  if Pos(SIUTILS_QUOTE_SINGLE, AString) < 0 then
    Exit;
  xString := '';
  for i := 1 to Length(AString)  do
  begin
    xChar := AString[i];
    if xChar = SIUTILS_QUOTE_SINGLE then
      xChar := SIUTILS_QUOTE_SINGLE + SIUTILS_QUOTE_SINGLE;
     xString := xString + xChar;
  end;
  Result := xString;
end;

function SiDeleteDirectory(const ADirectoryName: string): Boolean;
var
  xIndex: Integer;
  xSearchRec: TSearchRec;
  xDir: string;
  xFileName: string;
begin
  xDir := ADirectoryName + '\*.*';
  xIndex := FindFirst(xDir, faAnyFile, xSearchRec);

  while xIndex = 0 do
  begin
    xFileName := ExtractFileDir(xDir)+'\'+xSearchRec.name;
    if xSearchRec.Attr = faDirectory then
    begin
      if (xSearchRec.name <> '' ) and
         (xSearchRec.name <> '.') and
         (xSearchRec.name <> '..') then
        SiDeleteDirectory(xFileName);
    end
    else
    begin
      {$WARNINGS OFF}
      if xSearchRec.Attr <> faArchive then
        FileSetAttr(xFileName, faArchive);
      {$WARNINGS ON}
      if not SysUtils.DeleteFile(xFileName) then
        ShowMessage('    ' + xFileName);
    end;
    xIndex := FindNext(xSearchRec);
  end;
  //
  SysUtils.FindClose(xSearchRec);
  //
  RemoveDir(ExtractFileDir(xDir));
  Result := True;
end;

function SiIsSQLFieldNotSimple(AField: string): Boolean;
var
  xField: string;
begin
  Result := true;
  xField := trim(xField);
  if Pos('(', AFIeld) > 0 then
    Result := false;
  if Pos(')', AFIeld) > 0 then
    Result := false;
  if Pos(' ', AFIeld) > 0 then
    Result := false;
  if Pos(',', AFIeld) > 0 then
    Result := false;
end;

//     
function SiFieldTypeToStr(AFieldType: TFieldType): string;
begin
  Result := 'ftUnknown';
  case AFieldType of
    ftUnknown:    Result := 'ftUnknown';
    ftString:     Result := 'ftString';
    ftSmallint:	  Result := 'ftSmallint';
    ftInteger:	  Result := 'ftInteger';
    ftWord:	  Result := 'ftWord';
    ftBoolean:	  Result := 'ftBoolean';
    ftFloat:	  Result := 'ftFloat';
    ftCurrency:	  Result := 'ftCurrency';
    ftBCD:        Result := 'ftBCD';
    ftDate:       Result := 'ftDate';
    ftTime:	  Result := 'ftTime';
    ftDateTime:	  Result := 'ftDateTime';
    ftBytes:	  Result := 'ftBytes';
    ftVarBytes:	  Result := 'ftVarBytes';
    ftAutoInc:	  Result := 'ftAutoInc';
    ftBlob:	  Result := 'ftBlob';
    ftMemo:	  Result := 'ftMemo';
    ftGraphic:	  Result := 'ftGraphic';
    ftFmtMemo: 	  Result := 'ftFmtMemo';
    ftParadoxOle: Result := 'ftParadoxOle';
    ftDBaseOle:   Result := 'ftDBaseOle';
    ftTypedBinary:Result := 'ftTypedBinary';
    ftCursor:     Result := 'ftCursor';
    ftFixedChar:  Result := 'ftFixedChar';
    ftWideString: Result := 'ftWideString';
    ftLargeint:   Result := 'ftLargeint';
    ftADT:        Result := 'ftADT';
    ftArray:      Result := 'ftArray';
    ftReference:  Result := 'ftReference';
    ftDataSet:    Result := 'ftDataSet';
    ftOraBlob:    Result := 'ftOraBlob';
    ftOraClob:    Result := 'ftOraClob';
    ftVariant:    Result := 'ftVariant';
    ftInterface:  Result := 'ftInterface';
    ftIDispatch:  Result := 'ftIDispatch';
    ftGuid:       Result := 'ftGuid';
    ftTimeStamp:  Result := 'ftTimeStamp';
    ftFMTBcd:     Result := 'ftFMTBcd';
  end;
end;

//     
function SiStrToFieldType(const AStr: string): TFieldType;
begin
  Result := ftUnknown;
  if AStr = 'ftUnknown' then Result := ftUnknown;
  if AStr = 'ftString' then Result := ftString;
  if AStr = 'ftSmallint' then Result := ftSmallint;
  if AStr = 'ftInteger' then Result := ftInteger;
  if AStr = 'ftWord' then Result := ftWord;
  if AStr = 'ftBoolean' then Result := ftBoolean;
  if AStr = 'ftFloat' then Result := ftFloat;
  if AStr = 'ftCurrency' then Result := ftCurrency;
  if AStr = 'ftDate' then Result := ftDate;
  if AStr = 'ftBCD' then Result := ftBCD;
  if AStr = 'ftTime' then Result := ftTime;
  if AStr = 'ftDateTime' then Result := ftDateTime;
  if AStr = 'ftBytes' then Result := ftBytes;
  if AStr = 'ftVarBytes' then Result := ftVarBytes;
  if AStr = 'ftAutoInc' then Result := ftAutoInc;
  if AStr = 'ftBlob' then Result := ftBlob;
  if AStr = 'ftMemo' then Result := ftMemo;
  if AStr = 'ftGraphic' then Result := ftGraphic;
  if AStr = 'ftFmtMemo' then Result := ftFmtMemo;
  if AStr = 'ftParadoxOle' then Result := ftParadoxOle;
  if AStr = 'ftDBaseOle' then Result := ftDBaseOle;
  if AStr = 'ftTypedBinary' then Result := ftTypedBinary;
  if AStr = 'ftCursor' then Result := ftCursor;
  if AStr = 'ftFixedChar' then Result := ftFixedChar;
  if AStr = 'ftWideString' then Result := ftWideString;
  if AStr = 'ftLargeint' then Result := ftLargeint;
  if AStr = 'ftADT' then Result := ftADT;
  if AStr = 'ftArray' then Result := ftArray;
  if AStr = 'ftReference' then Result := ftReference;
  if AStr = 'ftDataSet' then Result := ftDataSet;
  if AStr = 'ftOraBlob' then Result := ftOraBlob;
  if AStr = 'ftOraClob' then Result := ftOraClob;
  if AStr = 'ftVariant' then Result := ftVariant;
  if AStr = 'ftInterface' then Result := ftInterface;
  if AStr = 'ftIDispatch' then Result := ftIDispatch;
  if AStr = 'ftGuid' then Result := ftGuid;
  if AStr = 'ftTimeStamp' then Result := ftTimeStamp;
  if AStr = 'ftFMTBcd' then Result := ftFMTBcd;
end;

//      BDE
function SiBDEExists: Boolean;
begin
  with TRegistry.Create do
  begin
    Rootkey := HKEY_LOCAL_MACHINE;
    Result := OpenKey('SOFTWARE\BORLAND\DATABASE ENGINE', False);
    Free;
  end;
end;

//     AFileName   ,
//  C:\Temp\picture.jpg D:\New\ => D:\New\picture.jpg
// .      ,      
function SiReplacePath(AFileName, APath: string): string;
var
  xFileName: string;
begin
  xFileName := ExtractFileName(AFileName);
  Result := APath + xFileName;                     
{  if xFileName = AFileName then
    Result := APath + '\' + xFileName
  else
    Result := APath + xFileName}
end;

//    
function SiGetTempDir: string;
var
  xBuffer: array[0..1023] of Char;
begin
  SetString(Result, xBuffer, GetTempPath(SizeOf(xBuffer)-1, xBuffer));
end;

function SiGetTempPath: string;
begin
  Result := SiGetTempDir;
end;

//    ApplicationData
// ,       
// (C:\Documents and Settings\username\Application Data)
function SiGetApplicationData: string;
var
  xPItemID : PItemIDList;
  xAnsiBuf : array[0..MAX_PATH] of char;
begin
  SHGetSpecialFolderLocation(Application.Handle, CSIDL_APPDATA, xPItemID );
  SHGetPathFromIDList( xPItemID, @xAnsiBuf[0] );
  Result := xAnsiBuf;
end;

//    ApplicationData
// AppData  ,      
// ( C:\Documents and Settings\username\Local Settings\Application Data)
function SiGetLocalApplicationData: string;
const
  CSIDL_LOCAL_APPDATA             = $1c;
var
  xPItemID : PItemIDList;
  xAnsiBuf : array[0..MAX_PATH] of char;
begin
  SHGetSpecialFolderLocation(Application.Handle, CSIDL_LOCAL_APPDATA, xPItemID );
  SHGetPathFromIDList( xPItemID, @xAnsiBuf[0] );
  Result := xAnsiBuf;
end;

//    ApplicationData
//  AppData   .
// ( C:\Documents and Settings\All Users\Application Data)
function SiGetCommonApplicationData: string;
const
  CSIDL_COMMON_APPDATA            = $23;
var
  xPItemID : PItemIDList;
  xAnsiBuf : array[0..MAX_PATH] of char;
begin
  SHGetSpecialFolderLocation(Application.Handle, CSIDL_COMMON_APPDATA, xPItemID );
  SHGetPathFromIDList( xPItemID, @xAnsiBuf[0] );
  Result := xAnsiBuf;
end;

//     
function GetFullVersion: string;
type
  TVersInfo=packed record
    Reversed: array[0..47] of byte; //   48 
    Minor, Major, Build, Release: word; //   
  end;
var
  xRes: TResourceStream;
  v: TVersInfo;
begin
  Result:='';
  xRes:=TResourceStream.Create(HInstance, '#1', RT_VERSION);
  try
    //  
    if xRes.Size > 0 then
    begin
      xRes.Read(v, SizeOf(v)); //    
      //   ...
      Result := IntToStr(v.Major)+'.'+IntToStr(v.Minor)+'.'+
                IntToStr(v.Release)+'.'+IntToStr(v.Build);
    end;
  except
    xRes.Free;
  end;
end;

//     
function GetSmallVersion: string;
type
  TVersInfo=packed record
    Reversed: array[0..47] of byte; //   48 
    Minor, Major, Build, Release: word; //   
  end;
var
  xRes: TResourceStream;
  v: TVersInfo;
begin
  Result:='';
  xRes:=TResourceStream.Create(HInstance, '#1', RT_VERSION);
  try
    //  
    if xRes.Size > 0 then
    begin
      xRes.Read(v, SizeOf(v)); //    
      //   ...
      Result := IntToStr(v.Major)+'.'+IntToStr(v.Minor);
    end;
  except
    xRes.Free;
  end;
end;

//    
function GetDateCompile: TDateTime;
var
  xSearchRec: TSearchRec;
  xIndex: Integer;
begin
  Result := 0;
  xIndex := FindFirst(ExpandFileName(Application.ExeName), faAnyFile, xSearchRec);
  if xIndex = 0 then
    Result := FileDateToDateTime(xSearchRec.Time);
  SysUtils.FindClose(xSearchRec);
end;

//       
procedure GetRegisteredProvidersList(AList: TStrings;
  const AFindKey, AFindName, AFindValue: WideString);
const
  REGKEY_PROGID = 'ProgID';
var
  xRegistry: TRegistry;
  xCLSIDEntries: TStringList;
  i: integer;
  xValue: string;
begin
  if not Assigned(AList) then
    exit;
  AList.Clear;
  xRegistry := TRegistry.Create;
  xCLSIDEntries := TStringList.Create;
  try
    xRegistry.RootKey := HKEY_CLASSES_ROOT;
    //    CLSID
    xRegistry.OpenKeyReadOnly('CLSID');
    xRegistry.GetKeyNames(xCLSIDEntries);
    for i:=0 to xCLSIDEntries.Count-1 do
    begin
      try
        if not xRegistry.OpenKeyReadOnly('\CLSID\'+xCLSIDEntries[i]+'\'+AFindKey) then
          continue;
        xValue := xRegistry.ReadString(AFindName);
        // -  ProgID
        if AnsiContainsText(xValue, AFindValue) then
        begin
          //      ProgID,    ,     
          if not ((AnsiCompareText(AFindKey,REGKEY_PROGID)=0) and (AFindName='')) then
          begin
            if not xRegistry.OpenKeyReadOnly('\CLSID\'+xCLSIDEntries[i]+'\'+REGKEY_PROGID) then
              continue;
            xValue := xRegistry.ReadString('');
          end;
          AList.Add(xValue)
        end; //if AnsiContainsText(xValue, AFindValue)
      except
      end;
    end; //for i:=0 to xCLSIDEntries.Count-1
  finally
    xCLSIDEntries.Free;
    xRegistry.Free;
  end;
end;

//    - AMemo -  AFindTExt -   ALastPosition -   
function SiFindTextInMemo(AMemo: TCustomMemo; var AFindTExt: string; var ALastPosition: LongInt): Boolean;
var
  xPos: LongInt;
  xUpperMem, xUpperFindText: string;
begin
  xUpperMem := ANSIUpperCase(AMemo.Lines.Text);
  xUpperMem := Copy(xUpperMem, ALastPosition, Length(xUpperMem) - ALastPosition + 1);
  xUpperFindText := ANSIUpperCase(AFindTExt);
  xPos := Pos(xUpperFindText, xUpperMem);
  Result := (xPos  > 0);
  if Result then
  begin
    //  
   if ALastPosition = 0 then
      AMemo.SelStart := xPos - 1;
    if ALastPosition > 0 then
      AMemo.SelStart := ALastPosition + xPos - 2;
    //  
    AMemo.SelLength := Length(xUpperFindText);
    ALastPosition := ALastPosition + xPos + Length(xUpperFindText) - 1;
  end;
end;

procedure SiPaintRichWord(ARich: TRichEdit; AWord: string; var APosition: LongInt; AColor: TColor);
var
  xPos, xLength: longInt;
  xSQL: string;
begin
  xSQL := Copy(ARich.Text, APosition, Length(ARich.Text) - APosition);
  xSQL := ANSIUpperCase(xSQL);
  xLength := Length(AWord);
  xPos := Pos(ANSIUpperCase(AWord), xSQL);
  if xPos > 0 then
  begin

    //     
    if (xPos > 1) and (ANSIIndexStr(xSQL[xPos - 1], SiTextSparators) = -1) then
    begin
      APosition := APosition + xPos + xLength;
      Exit;
    end;
    //     
    if ( (xPos + xLength ) < Length(xSQL) ) and (ANSIIndexStr(xSQL[xPos + xLength], SiTextSparators) = -1) then
    begin
      APosition := APosition + xPos + xLength;
      Exit;
    end;
    // 
    with ARich do
    begin
      if APosition = 0 then
        SelStart := APosition + xPos - 1
      else
        SelStart := APosition + xPos - 2;
      SelLength := xLength;
      SelAttributes.Style := SelAttributes.Style + [fsBold];
      SelAttributes.Color := AColor;
    end;
    //  
    APosition := APosition + xPos + xLength;
  end;
  if xPos <= 0 then
    APosition := -1;
end;

procedure SiClearRichWord(ARich: TRichEdit; AColor: TColor);
var
  xLength, xLastSelStart, xLastSelLength: LongInt;
begin
  xLength := Length(ARich.Text);
  with ARich do
  begin
     //   
     xLastSelStart := SelStart;
     xLastSelLength := SelLength;
     //   
     SelStart := 0;
     SelLength := xLength;
     SelAttributes.Style := SelAttributes.Style - [fsBold];
     SelAttributes.Color := AColor;
     //   
     SelStart := xLastSelStart;
     SelLength := xLastSelLength;
  end;
end;

end.

